
jQuery(document).ready(function ($) {    



    const loader = `<div class="dsb-spinner"><div></div><div></div><div></div><div></div></div>`;
    function loaderToEl(el,action='') {

        if (action=='') {
            el.append(loader);
        } else {
            el.find(".dsb-spinner").remove();
        }

    }



    function updateNcodeSelectBox() {

        let platform_id_selected = $(".datalogics_shipping_method_box option:selected").val();   
        let platform_id_post_id  = $(".datalogics_shipping_method_box").data("post-id");   
        $("#datalogics_n_code_" + platform_id_post_id).find("option:not([data-platform-id='"+platform_id_selected+"'])").hide(0);
        $("#datalogics_n_code_" + platform_id_post_id).find("option[data-platform-id='"+platform_id_selected+"']").show(0);
        $("#datalogics_n_code_" + platform_id_post_id + " option").eq(0).show(0);

    }

    updateNcodeSelectBox();

    $(document).on("change",".datalogics_shipping_method_box",function(){

        updateNcodeSelectBox();

    })


    $(".datalogics-bulk.print").on("click",function(){
        let selectedList = [];
        $(".type-shop_order").find(".check-column input[name='post[]']:checked").each(function() {
            selectedList.push( $(this).val() )
        })
        console.log('selectedList',selectedList)

        if (selectedList.length>0) {

            var href = object_data.print_link + selectedList.join(",")
            printPopup(href)

        } else {

            alert('יש לסמן את הזמנות שברצונכם להדפיס');

        }
    });


    $(".datalogics-bulk.send,.datalogics-bulk.cancel").on("click",function(){

        let el = $(this);

        loaderToEl(el)

        let ordersList = [];

        $(".check-column").find("input:checked").each(function(){

            ordersList.push($(this).val());

        });
        

        if (ordersList.length>0) {

            let action = '';
            let modal = '';

            if (el.hasClass("cancel")) {

                modal = $(".dso-bulk-cancel-modal");
                action = 'datalogics_get_bulk_cancel';

            } else {

                modal = $(".dso-bulk-send-modal");
                action = 'datalogics_get_bulk_shipping';

            }

            let data = {
                action : action,
                orders : ordersList.join(",")
            }

            $.ajax(object_data.ajax_url, {
                type: 'POST',  // http method
                data: data,  // data to submit
                success: function (data, status, xhr) {

                    modal.find(".dso-con-box").html(data);
                    modal.show(0)

                    loaderToEl(el,1)

                }
            });

        } else {

            loaderToEl(el,1)

            let modal = $(".dso-error-modal");
            modal.find(".dso-con-box .dso-error-modal-box").html('לא בחרתם הזמנות! יש לבחור הזמנות ולנסות שנית');
            modal.show(0)

        }

    })

    

    $('.datalogics_carrier_type').change(function() {
        $('.datalogics_carrier_type').not(this).prop('checked', false);
    });

    $(".datalogics-orders-colum").on('click',".dso-row-btn.edit", function (e) {

        let el = $(this);
        loaderToEl(el)

        let order_id = $(this).closest(".datalogics-orders-colum").data("order-id");

        let data = {
            action : 'datalogics_get_datalogics_fields',
            order_id : order_id
        }

        $.ajax(object_data.ajax_url, {
            type: 'POST',  // http method
            data: data,  // data to submit
            success: function (data, status, xhr) {

                let modal = $(".dso-send-modal");
                modal.find(".dso-con-box").html(data);
                modal.show(0)

                loaderToEl(el,1)

                updateNcodeSelectBox();

            }
        });

    });


    


    $(".datalogics_shipping_method_box").on("change",function(){

        var platform_id = $(this).val();

        var parent = $(this).closest(".datalogics-shipping-box");

        var box = parent.find(".datalogics_n_code");

        box.find("option:not([data-platform-id='"+platform_id+"'])").hide();
        box.find("option[data-platform-id='"+platform_id+"']").show();
        box.find("option:first").show();

        if (platform_id==52) { //zigzag

            parent.find(".zigzag-box").show();

        } else {
            parent.find(".zigzag-box").hide();
        }

    })


    $(".dso-bulk-send-modal").on("click",".dso-row-btn.delete",function(){

        $(this).closest("tr").remove();

    });


    $(".dso-bulk-send-modal").on("click",".datalogics_bulk.submit", async function(e){

        let ordersList = {};

        let modal = $(".dso-bulk-send-modal");

        modal.find("tr").each(function(){

            let order_id = $(this).data("order-id")
            if (order_id!='') {

                ordersList[order_id] = { 
                    order_id : order_id
                }
            }

        });

        if (Object.keys(ordersList).length>0) {   
            
            for(var key in ordersList) {                        
           
                e.preventDefault();
                let el = $(this);
                console.log(ordersList[key]);
                await submit_or_cancel_shipment(el,ordersList[key]);                

            }           

        } else {

            loaderToEl(el,1)

            let modal = $(".dso-error-modal");
            modal.find(".dso-con-box .dso-error-modal-box").html('לא בחרתם הזמנות לשידור! יש לבחור הזמנות ולנסות שנית');
            modal.show(0)

        }

    });



    $(".dso-bulk-cancel-modal").on("click",".datalogics_bulk.cancel",function(e){

        let ordersList = {};

        let modal = $(".dso-bulk-cancel-modal");

        modal.find("tr").each(function(){

            let order_id = $(this).data("order-id")
            let tracking_number = $(this).data("tracking-number")
            if (order_id!='') {

                ordersList[order_id] = { 
                    order_id : order_id,
                    tracking_number : tracking_number
                }
            }

        });

        if (Object.keys(ordersList).length>0) {   
            
            for(var key in ordersList) {                          
           
                e.preventDefault();
                let el = $(this);
                submit_or_cancel_shipment(el,ordersList[key]);                

            }           

        } else {

            loaderToEl(el,1)

            let modal = $(".dso-error-modal");
            modal.find(".dso-con-box .dso-error-modal-box").html('לא בחרתם הזמנות לשידור! יש לבחור הזמנות ולנסות שנית');
            modal.show(0)

        }

    });


    $(".dso-modal").on("click",".dso-con-title span",function(){


        let modal = $(".dso-modal");
        modal.hide(0)


    })

    $(".datalogics-orders-colum").on("click",".dso-row-btn.print",function(){

        var href = $(this).data("label")

        printPopup(href)

        //console.log(href)

        //viewFile(href)

    })

    $(document).on("click",".datalogics_submit.print_label",function(){

        var href = $(this).data("label")

        printPopup(href);

        //console.log(href)

        //viewFile(href)

    })

    function printPopup(href) {

        window.open(href, '_blank', 'location=yes,height=570,width=520,scrollbars=yes,status=yes');

    }

    $(".datalogics-shipping-box").on('click',".datalogics_check_status", function (e) {

        e.preventDefault();
        let el = $(this);
        let order_id = el.closest(".datalogics-shipping-exist-box").data("order-id")
        checkStatus(order_id,el)
        
    });


    $(".datalogics-orders-colum").on("click",".dso-row-btn.status",function(){
        let el = $(this);
        let order_id = el.data("order-id")
        checkStatus(order_id,el)

    })
    

    


    $(".datalogics-orders-colum").on("click",".dso-row-btn.send,.dso-row-btn.cancel",function(e){

        e.preventDefault();
        let el = $(this);
        submit_or_cancel_shipment(el);
    })  

    



    $(".datalogics-shipping-box").on('click',".datalogics_submit.submit,.datalogics_submit.cancel", function (e) {

        e.preventDefault();
        let el = $(this);
        submit_or_cancel_shipment(el);
        
    });

    $(".dso-send-modal").on("click",".datalogics_submit.submit,.datalogics_submit.cancel",function(e){

        e.preventDefault();
        let el = $(this);
        submit_or_cancel_shipment(el);

    });

    function checkStatus(order_id,el) {

        loaderToEl(el);
        
        var button = el;

        button.attr("disabled", 1)


        let data = {
            action: 'datalogics_check_order_shipping_status',
            order_id:order_id
        }


        $.ajax(object_data.ajax_url, {
            type: 'POST',  // http method
            data: data,  // data to submit
            success: function (data, status, xhr) {


                let modal = $(".dso-status-modal");
                modal.find(".dso-con-box").html(data); 
                modal.show(0)             

                 
                button.prop("disabled",false)
                loaderToEl(el,1);


                
            },
            error: function (jqXhr, textStatus, errorMessage) {
                console.log(textStatus);

               
            }
        });

    }


    async function submit_or_cancel_shipment(el,post_order_id={}) {

        return new Promise((resolve, reject) => {

            if (el.attr("disabled") == 1) {
                resolve();
                return;
            }

            loaderToEl(el);

            if (el.hasClass("cancel")) {

                var action = 'datalogics_cancel_shipping';        

            } else {

                var action = 'datalogics_create_shipping';

            }   
            
            var parent = el.closest(".datalogics-shipping-box");
            if (parent.length==0) {
                parent = el.closest(".datalogics-cancel-box");            
            }        

            var tracking_number     = el.data("tracking-number");
            var comment             = parent.find('.datalogics_comment').val();
            var shipment_type       = parent.find('.datalogics_shipment_type option:selected').val();
            var govina_sum          = parent.find('.datalogics_govina_sum').val();
            var carrier_type        = parent.find('.datalogics_carrier_type:checked').val();
            var location            = parent.find('.datalogics_location option:selected').val();
            var fullname            = parent.find('.datalogics_fullname').val();
            var phone               = parent.find('.datalogics_phone').val();
            var address             = parent.find('.datalogics_address').val();
            var house               = parent.find('.datalogics_house').val();
            var city                = parent.find('.datalogics_city').val();
            var apartment           = parent.find('.datalogics_apartment').val();
            var entrance            = parent.find('.datalogics_entrance').val();
            var floor               = parent.find('.datalogics_floor').val();
            var door                = parent.find('.datalogics_door').val();
            var email               = parent.find('.datalogics_email').val();
            var packages            = parent.find('.datalogics_packs').val();
            var platform_id         = parent.find(".datalogics_shipping_method_box option:selected").val();
            var datalogics_order_id = parent.data("order-id");
            var datalogics_n_code   = parent.find(".datalogics_n_code option:selected").val();
            var error               = parent.find(".datalogics_error");
            var loader              = parent.find('.datalogics_loader');

            let order_row_column = el.closest(".datalogics-orders-colum");
            if (order_row_column.length>0) 
            {
                datalogics_order_id = order_row_column.data("order-id");
                if (el.hasClass("cancel")) { 
                    tracking_number = el.data("tracking-number")
                }
            }

            if (post_order_id && post_order_id.order_id) {

                datalogics_order_id = post_order_id.order_id;

                if (post_order_id.tracking_number) {

                    tracking_number = post_order_id.tracking_number;

                }

            }

            loader.show(0);

            var button = el;

            button.attr("disabled", 1)

            var data = {
                datalogics_tracking_number : tracking_number,
                datalogics_platform_id : platform_id,
                datalogics_order_id: datalogics_order_id,
                datalogics_comment: comment,
                datalogics_shipment_type: shipment_type,
                datalogics_govina_sum : govina_sum,
                datalogics_carrier_type: carrier_type,
                datalogics_location: location,
                action: action,

            }

            if (!post_order_id.order_id) {

                data.datalogics_fullname = fullname;
                data.datalogics_phone = phone;
                data.datalogics_address = address;
                data.datalogics_house = house;
                data.datalogics_city = city;
                data.datalogics_email = email;
                data.datalogics_apartment = apartment;
                data.datalogics_entrance = entrance;
                data.datalogics_floor = floor;
                data.datalogics_door = door;
                data.datalogics_packs = packages;
                data.datalogics_n_code = datalogics_n_code;

            }

            // console.log(data);

            // return;


            if (parent.find(".zigzag").length>0) {
                data.datalogics_user = parent.find(".zigzag:checked").val();
            }

            //console.log(data);

            $.ajax(object_data.ajax_url, {
                type: 'POST',  // http method
                data: data,  // data to submit
                success: function (data, status, xhr) {
                    var result = JSON.parse(data.body)

                    if (result.success) {

                        let order_row_div = $(".datalogics-orders-colum[data-order-id='"+datalogics_order_id+"']");
                        
                        if (order_row_div.length>0) 
                        {
                            var exist_order_row  = $(".datalogics-shipping-orders-container.dupe")[0].outerHTML;                            
                            exist_order_row  = $(exist_order_row);
                            exist_order_row.removeClass("dupe");
                            exist_order_row.show(0);
                        }

                        let bulk_shipment_table = parent.find(".dso-con-table");
                        if (bulk_shipment_table.length>0) {

                            bulk_shipment_table
                                .find("tr[data-order-id='"+datalogics_order_id+"']")
                                .find(".verified")
                                .addClass("verified_icon")

                        }

                        //var_dump(result);

                        if (action == 'datalogics_create_shipping') {

                            if (!result.label_url) {
                                result.label_url = object_data.print_link + datalogics_order_id;
                            }                        
                            
                            var exist_box_tracking  = $(".datalogics-shipping-exist-box.dupe");
                            if (exist_box_tracking.length>0) 
                            {                            
                                exist_box_tracking = exist_box_tracking[0].outerHTML; 
                                
                                exist_box_tracking  = $(exist_box_tracking);                            

                                exist_box_tracking.find(".datalogics_tracking_number").text(result.tracking_number)
                                exist_box_tracking.find(".datalogics_tracking_label").data("href",result.label_url);
                                exist_box_tracking.find(".download_label").data("label",result.label_url);
                                exist_box_tracking.find(".print_label").data("label",result.label_url);
                                exist_box_tracking.find(".dsb-shipping-comapny").text(result.platform_name);
                                exist_box_tracking.find(".dsb-shipping-location").text(result.location_name);
                                exist_box_tracking.find(".datalogics_submit").data('tracking-number',result.tracking_number);
                                let src = exist_box_tracking.find(".dbs-barcode img").attr("src");
                                exist_box_tracking.find(".dbs-barcode img").attr("src",src + result.tracking_number);

                                exist_box_tracking.show(0)
                                exist_box_tracking.removeClass("dupe")

                                $(".datalogics-shipping-exist").append(exist_box_tracking);
                                $(".dsb-sender-box").hide(0);

                                parent.addClass("shipped");

                            }

                            /** if orders page */
                            
                            if (order_row_div.length>0) {

                                exist_order_row.find(".dso-row-btn.send").remove()
                                exist_order_row.find(".dso-row-btn.edit").remove()
                                exist_order_row.find(".dso-row-method").remove()                            
                                exist_order_row.find(".dso-row-btn.print").data("label",result.label_url)
                                exist_order_row.find(".dso-row-tracking-number").html(result.tracking_number)
                                exist_order_row.find(".dso-row-btn.cancel").data("tracking-number",result.tracking_number);
                                order_row_div.find(".datalogics-shipping-orders-container:not(.dupe)").remove(); 
                                order_row_div.append(exist_order_row)

                            }
                            

                        }
                        else {

                            parent.removeClass("shipped");


                            button.closest(".datalogics-shipping-exist-box").remove();
                            $(".dsb-sender-box").show(0);

                            if (order_row_div.length>0) {

                                exist_order_row.find(".dso-row-tracking-number").remove()
                                exist_order_row.find(".dso-row-btn.cancel").remove() 
                                exist_order_row.find(".dso-row-btn.print").remove() 
                                exist_order_row.find(".dso-row-btn.status").remove() 
                                order_row_div.find(".datalogics-shipping-orders-container:not(.dupe)").remove(); 
                                order_row_div.append(exist_order_row)

                            }
                            

                        }

                        error.html("")
                    }
                    else {
                        error.html(result.msg)
                    }

                    loader.hide(0)
                    button.prop("disabled",false)
                    loaderToEl(el,1);

                    console.log(JSON.parse(data.body));

                    resolve();
                },
                error: function (jqXhr, textStatus, errorMessage) {
                    console.log(textStatus);

                    resolve();
                }
            });

        });

    }


    // $(".datalogics-shipping-order-send-button").on("click",function(e){
    //
    //     e.preventDefault();
    //
    //     $(this).siblings(".datalogics-order-shipping-box-fixed").addClass("datalogics-show");
    //
    // })



    var orders_shipping_send = document.querySelectorAll(".datalogics-shipping-order-send-button");
    for (var i = 0; i < orders_shipping_send.length; i++) {

        orders_shipping_send[i].addEventListener('click', function (e) {

            e.preventDefault();
            var shipping_box = this.nextElementSibling;
            shipping_box.classList.add("datalogics-show");


        });
    }

    var prevent_order_open = document.querySelectorAll(".datalogics-order-shipping-box-fixed");
    for (var i = 0; i < prevent_order_open.length; i++) {

        prevent_order_open[i].addEventListener('click', function (e) {

            e.preventDefault();

        });
    }

    var orders_background_click = document.querySelectorAll(".datalogics-order-shipping-box-fixed-bg");
    for (var i = 0; i < orders_background_click.length; i++) {

        orders_background_click[i].addEventListener('click', function (e) {

            var shipping_box = this.parentElement;
            shipping_box.classList.remove("datalogics-show");

        });
    }


    // const viewFile = async (url) => {
    //
    //     var token = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJodHRwczovL3J1bmNvbS5jby5pbC9jbGFpbXMvY2xpZW50bm8iOiI3MzIzIiwiaHR0cHM6Ly9ydW5jb20uY28uaWwvY2xhaW1zL3BocmFzZSI6ImJiNDZkM2E0LWE0MzgtNDc1My05MmM1LTE4Mzk2ZTI5OTY1NCIsImV4cCI6MTY5NzYzMzA5OSwiaXNzIjoiaHR0cHM6Ly9ydW5jb20uY28uaWwiLCJhdWQiOiJodHRwczovL3J1bmNvbS5jby5pbCJ9.lMxDGMCK4C62geZb4tVjO5Yi3DGpLc-lP7Ipl6lTqhA';
    //
    //     var auth = {
    //         headers: {
    //             Authorization: "Bearer "+token,
    //         }
    //     }
    //
    //
    //     // Change this to use your HTTP client
    //     fetch(url, auth ) // FETCH BLOB FROM IT
    //         .then((response) => response.blob())
    //         .then((blob) => { // RETRIEVE THE BLOB AND CREATE LOCAL URL
    //             var _url = window.URL.createObjectURL(blob);
    //             window.open(_url, "_blank").focus(); // window.open + focus
    //         }).catch((err) => {
    //         console.log(err);
    //     });
    // };
    //
    //

    


});
