
jQuery(document).ready(function ($) {

    if ($(".settings-page").length) {

        

        $(document).on('input', '.shipping_push_supplier_contract', function(event) {
            let inputValue = $(this).val();

            // Remove non-digits and non-letters
            inputValue = inputValue.replace(/[^0-9a-zA-Z]/g, '');

            // Limit to 4 characters
            inputValue = inputValue.substring(0, 4);

            // Ensure the first two characters are digits
            if (inputValue.length >= 2 && !/^\d{2}/.test(inputValue)) {
                // If the first two characters are not digits, remove them
                inputValue = inputValue.substring(2);
            }

            $(this).val(inputValue);
        });

    }


    $(".dsp-box-menu a").on("click",function(e){

        e.preventDefault();

        let link = $(this).attr("href")

        history.pushState(null, null, link);

        $(this).siblings().removeClass("dsp-box-menu-selected")
        $(this).addClass("dsp-box-menu-selected")

        let con = $(this).data("con");

        let box = $("."+con)
        box.siblings().addClass("dsp-hide")
        box.removeClass("dsp-hide");
        

    })


    const checkKey = async () => {

        initLoader();

        let token = $("#datalogics_token").val();

        let validationBox = $(".dsp-validation");

        if (token=='') {
            
            validationBox.find(".invalid").removeClass("dsp-hide");
            $(".dsp-reg").removeClass("dsp-hide");
            initLoader(1);
            return;
        }
        

        let data = {
            action : 'datalogics_validate_key',
            token : token
        }        

        

        $.ajax(object_data_settings.ajax_url, {
            type: 'POST',  // http method
            dataType : 'json',
            data: data,  // data to submit
            success: function (data, status, xhr) {

                $(".dsp-products").addClass("dsp-hide")
                let prod_list = $(".dsp-products-list")
                prod_list.html('')

                let payment_link_div =  $(".dsp-payment-link");

                if (data.payment_link) {
                    payment_link_div.removeClass("dsp-hide")
                    payment_link_div.find("a").attr("href",data.payment_link)
                    payment_link_div.find("a").html(data.payment_link)
                } else {
                    payment_link_div.addClass("dsp-hide")
                }

                if (data.success==1) {

                    validationBox.find(".invalid").addClass("dsp-hide")
                    validationBox.find(".valid").removeClass("dsp-hide")
                    $(".dsp-reg").addClass("dsp-hide");

                    if (data.products) { 
                        
                        $(".dsp-products").removeClass("dsp-hide")

                        data.products.filter((prod)=> {

                            let prodHtml = `<div class="dsp-prod">
                                                <div class="dsp-prod-image"><img src="${prod.img}"></div>
                                                <div class="dsp-prod-name">${prod.name}</div>
                                            </div>`

                            prod_list.append(prodHtml)

                        })

                    }

                } else {

                    validationBox.find(".valid").addClass("dsp-hide")
                    validationBox.find(".invalid").removeClass("dsp-hide")
                    $(".dsp-reg").removeClass("dsp-hide");

                }

                initLoader(1);

            },
            error: function (jqXhr, textStatus, errorMessage) {

                initLoader(1);
                $(".dsp-reg").removeClass("dsp-hide");
            }
        });

    }

    checkKey();

    $("#datalogics_check_key").on("click",function(){    
        
        checkKey();
    })



    $(".dsp-locations-con").on("click",".dsp-location-box-close",function(){
        $(this).closest(".dsp-location-box").remove();
    });


    $(".dsp-companies-box").on("click",".dsp-companies-box-close",function(){
        $(this).closest(".dsp-companies-box").addClass("dsp-companies-box-hidden");
    });




    $(".dsp-companies-box").on("click",".shipping_push_supplier_default",function(){

        let id = $(this).attr("id");
        $(".dsp-companies-con").find(".shipping_push_supplier_default:not(#"+id+")").prop("checked",false);

    })

    $(".dsp-locations-con").on("click",".dsp-location-box-default",function(){

        let id = $(this).attr("id");
        $(".dsp-locations-con").find(".dsp-location-box-default:not(#"+id+")").prop("checked",false);

    })    

    $("#datalogics_save_companies").on("click",function(){ 

        initLoader();

        let datalogics_shipping_method = [];

        
        $(".dsp-companies-box").each(function(){


            if ($(this).hasClass("dsp-companies-box-hidden")) {

                return;

            }


            const company = {

                shipping_push_supplier : $(this).find(".shipping_push_supplier").val(),
                shipping_push_supplier_enable : $(this).find(".shipping_push_supplier_enable").prop("checked"),
                shipping_push_supplier_subscription_id : $(this).find(".shipping_push_supplier_subscription_id").val(),
                shipping_push_supplier_username1 : $(this).find(".shipping_push_supplier_username1").val(),
                shipping_push_supplier_username2 : $(this).find(".shipping_push_supplier_username2").val(),
                shipping_push_supplier_username3 : $(this).find(".shipping_push_supplier_username3").val(),
                shipping_push_supplier_password : $(this).find(".shipping_push_supplier_password").val(),
                shipping_push_supplier_code : $(this).find(".shipping_push_supplier_code").val(),
                shipping_push_supplier_code_pickup : $(this).find(".shipping_push_supplier_code_pickup").val(),
                shipping_push_supplier_token : $(this).find(".shipping_push_supplier_token").val(),
                shipping_push_supplier_default : $(this).find(".shipping_push_supplier_default").prop("checked"),
                shipping_push_supplier_auth_username : $(this).find(".shipping_push_supplier_auth_username").val(),
                shipping_push_supplier_auth_password : $(this).find(".shipping_push_supplier_auth_password").val(),
                shipping_push_supplier_username : $(this).find(".shipping_push_supplier_username").val(),
                shipping_push_supplier_contract : $(this).find(".shipping_push_supplier_contract").val(),
                shipping_push_supplier_pudo_contract : $(this).find(".shipping_push_supplier_pudo_contract").val(),
                shipping_push_supplier_end : $(this).find(".shipping_push_supplier_end").val(),
            }

            datalogics_shipping_method.push(company)


        })

        let data = {
            action : 'datalogics_update_companies',
            datalogics_shipping_method : datalogics_shipping_method
        }

        $.ajax(object_data_settings.ajax_url, {
            type: 'POST',  // http method
            dataType : 'json',
            data: data,  // data to submit
            success: function (data, status, xhr) {

                if (data.success==1) {

                    //$("#datalogics_token").val(data.token);                    

                } else {

                    alert(data.msg);

                }

                initLoader(1);

            },
            error: function (jqXhr, textStatus, errorMessage) {

                initLoader(1);
            }
        });


        

    });


    

    $("#datalogics_add_companies").on("click",function(){

        let value = $(this).siblings("select").find("option:selected").val();
        if (value=='') {
            return;
        }

        $(".dsp-companies-box"+value).removeClass("dsp-companies-box-hidden")

        $(".companies-container").find(".dsp-companies-con-empty").remove();

    })


    $("#datalogics_location_add").on("click",function(){

        let el = $(".dsp-location-box-hidden")[0].outerHTML;

        el = $(el);
        el.removeClass("dsp-location-box-hidden")


        $(".dsp-locations-con").find(".dsp-locations-con-empty").remove();

        $(".dsp-locations-con").append(el);

    })
    

    $("#datalogics_location_save").on("click",function(){ 

        var formValid = true;
        $('.dsp-location-box:not(.dsp-location-box-hidden) input[required]').each(function() {
            if ($(this).val().trim() === '') {
                $(this).addClass('datalogics-input-error');
                formValid = false;
            } else {
                $(this).removeClass('datalogics-input-error');
            }
        });
        if (formValid) {
            // Submit the form or perform other actions
            console.log('Form submitted successfully.');
        } else {
            // Form is not valid, prevent submission
            console.log('Form not submitted. Please fill in all required fields.');
            return;
        }

        initLoader();

        let datalogics_update_inventory_locations = [];

        $(".dsp-location-box").each(function(){

            if (!$(this).hasClass("dsp-location-box-hidden")) {  

                const location = {

                    id : $(this).find(".id").val(),
                    enable : $(this).find(".enable").prop("checked"),
                    name : $(this).find(".name").val(),
                    label : $(this).find(".label").val(),
                    city : $(this).find(".city").val(),
                    street : $(this).find(".street").val(),
                    house : $(this).find(".house").val(),
                    phone : $(this).find(".phone").val(),
                    default : $(this).find(".default").prop("checked"),
                }

                datalogics_update_inventory_locations.push(location)

            }


        })

        let data = {
            action : 'datalogics_update_inventory_locations',
            datalogics_update_inventory_locations : datalogics_update_inventory_locations
        }

        $.ajax(object_data_settings.ajax_url, {
            type: 'POST',  // http method
            dataType : 'json',
            data: data,  // data to submit
            success: function (data, status, xhr) {

                if (data.success==1) {

                              

                } else {

                    alert(data.msg);

                }

                initLoader(1);

            },
            error: function (jqXhr, textStatus, errorMessage) {

                initLoader(1);
            }
        });


        

    });

    $("#datalogics_register").on("click",function(){ 
        
        
        initLoader();
        

        var data = { 
            action : 'datalogics_register',
            datalogics_firstname : $("#datalogics_firstname").val() ,
            datalogics_lastname : $("#datalogics_lastname").val(),
            datalogics_company : $("#datalogics_company").val(),
            datalogics_vat_number : $("#datalogics_vat_number").val(),
            datalogics_email : $("#datalogics_email").val(),
            datalogics_phone : $("#datalogics_phone").val(),
        }
        let pass = true;

        for(var key in data) {

            if (data[key]!='') {

            } else {

                pass = false;

            }

        }

        if (pass==false) {

            initLoader(1);

            alert('יש למלות א כל הפרטים');
            return;
        }

        $.ajax(object_data_settings.ajax_url, {
            type: 'POST',  // http method
            dataType : 'json',
            data: data,  // data to submit
            success: function (data, status, xhr) {

                if (data.success==1) {

                    $("#datalogics_token").val(data.token);                    

                } else {

                    alert(data.msg);

                }

                

                initLoader(1);


            },
            error: function (jqXhr, textStatus, errorMessage) {

                checkKey();

                initLoader(1);
            }
        });



        
    })


    


    $("#datalogics_settings_save").on("click", function () {

        initLoader();
        
        var formData = { 
            action : 'datalogics_settings_save',
            datalogics_shipping_method : [] ,
            datalogics_token : $("#datalogics_token").val(),
            datalogics_myaccount_tracking : $("#datalogics_myaccount_tracking").prop("checked"),
            datalogics_myaccount_tracking_email : $("#datalogics_myaccount_tracking_email").prop("checked"),
            datalogics_myaccount_tracking_email_link : $("#datalogics_myaccount_tracking_email_link").val(),
            shipping_push_notes_in_comments : $("#shipping_push_notes_in_comments").prop("checked"),
            order_statuses_limit : $("#order_statuses_limit").val(),
            shipping_push_products_in_comments : $("#shipping_push_products_in_comments").prop("checked"),
            datalogics_cities_list : $("#datalogics_cities_list").prop("checked"),
            datalogics_cities_auto : $("#datalogics_cities_auto").prop("checked"),
            datalogics_cities_auto_validation : $("#datalogics_cities_auto_validation").prop("checked"),
            datalogics_ncode_auto : $("#datalogics_ncode_auto").prop("checked"),
            datalogics_skip_jquery : $("#datalogics_skip_jquery").prop("checked"),
            order_statuses : $("#order_statuses option:selected").val(),
            datalogics_google_key : $("#datalogics_google_key").val(),
            datalogics_shipping_options_enabled : $("#datalogics_shipping_options_enabled").prop("checked"),
            datalogics_shipping_options : $("#datalogics_shipping_options").val(),
            datalogics_view_option : $("#datalogics_view_option option:selected").val(),
            datalogics_billing_map_street : $("#map_billing_street").val(),
            datalogics_billing_map_house : $("#map_billing_house").val(),
            datalogics_billing_map_apartment : $("#map_billing_apartment").val(),
            datalogics_billing_map_entrance : $("#map_billing_entrance").val(),
            datalogics_billing_map_floor : $("#map_billing_floor").val(),
            datalogics_billing_map_door : $("#map_billing_door").val(),
            datalogics_shipping_map_street : $("#map_shipping_street").val(),
            datalogics_shipping_map_house : $("#map_shipping_house").val(),
            datalogics_shipping_map_apartment : $("#map_shipping_apartment").val(),
            datalogics_shipping_map_entrance : $("#map_shipping_entrance").val(),
            datalogics_shipping_map_floor : $("#map_shipping_floor").val(),
            datalogics_shipping_map_door : $("#map_shipping_door").val(),
            datalogics_print_logo : $("#datalogics_upload_image_value").val(),
            datalogics_print_pattern : $("#datalogics_print_pattern option:selected").val(),
            datalogics_custom_label : $("#datalogics_custom_label").prop("checked"),

        }
        var counter  = 0;

 
        $(".shipping_company_item").each(function(){  
            
            var element = $(this);
              
            var inputData = {
                shipping_push_supplier_id : element.data("company-id"),
                shipping_push_supplier : element.data("company-id")
            };
            
            element.find("input").each(function(){  

                var input = $(this);

                var name = input.attr("name");
                var value = input.val();

                if (value=='') {

                    initLoader(1);
                    alert('please fill all fields');  
                                        
                    return;                 
                }

                inputData[name] = value;

            })

            formData['datalogics_shipping_method'].push(inputData);

        });


        $.ajax(object_data_settings.ajax_url, {
            type: 'POST',  // http method
            data: formData,  // data to submit
            success: function (data, status, xhr) {

                initLoader(1);

                var result = data;
                //var result = JSON.parse(data.body)

                

                if (result.success) {

                    alert('הנתונים נשמרו בהצלחה');
                }
                else {
                    //error.html(result.msg)
                }

                

            },
            error: function (jqXhr, textStatus, errorMessage) {

                initLoader(1);
                console.log(textStatus);
            }
        });

        

    });


    $("#datalogics_shipping_options_enabled").on("click", function () {

        if ($(this).prop("checked")) {

            $("#datalogics_shipping_options").attr("disabled", false)

        } else {
            $("#datalogics_shipping_options").prop("disabled", true)
        }

    })

    

    $(".companies_list").on("click",".shipping_company_item_delete", function () {

        var z = confirm("האם אתה בטוח שתרצה למחוק?");

        if (z == true) {

            $(this).parent().remove();

        };

    });


    
    
    function initLoader(action='') {

        if (action=='') {

            $("#datalogics_loader_con").removeClass("hide");

        } else {

            $("#datalogics_loader_con").addClass("hide");

        }

    }




    // File input change event handler
    $('#datalogics_print_logo_image').on('change', function() {
        var input = $(this)[0];
        var imageContainer = $('.current-image-container');

        if (input.files && input.files[0]) {
            var formData = new FormData();
            formData.append('file', input.files[0]);

            // Get the nonce value from the hidden input field
            var nonce = $('#datalogics_upload_image_nonce').val();
            formData.append('nonce', nonce);
            formData.append('action','datalogics_handle_file_upload');

            // Trigger AJAX request
            $.ajax({
                url: object_data_settings.ajax_url, // WordPress AJAX URL
                type: 'POST',
                data: formData,
                processData: false,
                contentType: false,
                success: function(response) {
                    if (response.success) {
                        //alert(response.data.url)
                        // Display the uploaded image
                        var img = $('<img>').attr('src', response.data.url);
                        imageContainer.html(img);
                        $("#datalogics_upload_image_value").val(response.data.url);
                    } else {
                        console.error('Error uploading image: ' + response.data.message);
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    console.error('AJAX error: ' + textStatus + ' ' + errorThrown);
                }
            });
        } else {
            imageContainer.empty();
        }
    });


    $("#datalogics_upload_image_delete").on("click",function(){
        $("#datalogics_upload_image_value").val('');
        $(".current-image-container").html('');
    })



});
