<?php

$datalogics_shipping_woo_page = '';
$datalogics_shipping_woo_type = 1;


if(strpos( $_SERVER['REQUEST_URI'], 'post.php') || strpos( $_SERVER['REQUEST_URI'], 'edit.php') || strpos( $_SERVER['REQUEST_URI'], 'admin.php')) {

    if (isset($_GET)) {

        $id = '';
        if (isset($post)) {
            $id = $post->ID;
        }

        if (isset($_GET['post'])) {
            $id = $_GET['post'];
        }

        if (isset($_GET['page']) && $_GET['page']=='wc-orders') {

            $datalogics_shipping_woo_type = 2;
            $datalogics_shipping_woo_page = 'orders';

            if (isset($_GET['action']) && $_GET['action']=='edit') {
                $datalogics_shipping_woo_page = 'edit';
                
            }
        } else if (isset($_GET['post_type']) && $_GET['post_type']=='shop_order') {

            $datalogics_shipping_woo_type = 1;
            $datalogics_shipping_woo_page = 'orders';

        }

        if (get_post_type($id) == "shop_order") {
            
            $datalogics_shipping_woo_page = 'edit';
            
        }

        add_action('admin_enqueue_scripts', 'datalogics_my_script_enqueue');

    }

}



//Load Scripts only on order pages!
function datalogics_my_script_enqueue() {

    global $datalogics_shipping_woo_page;

    $path = 'admin.php?page=datalogics-settings';

    $settings_url = admin_url($path);    

    $settings = array();

    $settings['shipping_push_supplier_code'] = get_option('shipping_push_supplier_code');
    $settings['shipping_push_supplier_name'] = get_option('shipping_push_supplier_name');
    $settings['shipping_push_supplier_city'] = get_option('shipping_push_supplier_city');
    $settings['shipping_push_supplier_street'] = get_option('shipping_push_supplier_street');
    $settings['shipping_push_supplier_house'] = get_option('shipping_push_supplier_house');
    $settings['shipping_push_products_in_comments'] = get_option('shipping_push_products_in_comments');
    $settings['shipping_push_supplier'] = get_option('shipping_push_supplier');
    $settings['user_id'] = get_current_user_id();

    $settings['firstname']  = get_option('firstname');
    $settings['lastname']   = get_option('lastname');
    $settings['company']    = get_option('company');
    $settings['email']      = get_option('email');
    $settings['phone']      = get_option('phone');
    $token = get_option('datalogics_token', '');

    $object_data = array(
        "print_link"=>DATALOGICS_PRINT_URL,
        "token" => $token, 
        "settings" => $settings, 
        "submit_error" => __('You didnt finish your configuration, please go to <a href='.$settings_url.'>settings</a> and complete the configuration!','datalogics_shipping'), 
        'ajax_url' => admin_url( 'admin-ajax.php' ), 
        "submit" => __('Submit','datalogics_shipping'), 
        "cancel" => __('Cancel', 'datalogics_shipping')
    );

    if($datalogics_shipping_woo_page == 'edit'){

        $id = (isset($_GET['post'])) ? $_GET['post'] : $_GET['id'];

        $order = new WC_Order( $id );

        $object_data['order_data'] = $order->get_data();

    }    
    
    wp_enqueue_style('empty-plugin-style', add_query_arg( DATALOGICS_ARGS,plugins_url( '/css/style_admin.css', __FILE__ ) ));
    wp_enqueue_script( 'datalogics-scripts',  add_query_arg( DATALOGICS_ARGS,plugins_url( '/js/scripts.js', __FILE__ ) ));
    wp_localize_script( 'datalogics-scripts', 'object_data', $object_data );

    
}

//admin_print_scripts-edit.php



if (in_array($datalogics_shipping_woo_page,['edit','orders'])) {
   
    add_filter('admin_footer','add_filter_datalogics_shipping');

    function add_filter_datalogics_shipping() {

        ?>
        <div class="dso-modal dso-status-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title"><?php echo __('Shipment Status', 'datalogics_shipping')?><span></span></div>
                <div class="dso-con-box"> 
                </div>
            </div>
        </div>

        <div class="dso-modal dso-send-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title">
                    <div><?php echo __('Send Shipping', 'datalogics_shipping')?></div>
                    <span></span>
                </div>
                <div class="dso-con-box">
                <?php //datalogics_fields(1); ?>
                </div>
            </div>
        </div>

        <div class="dso-modal dso-bulk-send-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title"><?php echo __('Bulk Shipment', 'datalogics_shipping')?><span></span></div>
                <div class="dso-con-box"> 
                </div>
            </div>
        </div>

        <div class="dso-modal dso-bulk-cancel-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title"><?php echo __('Bulk Cancel', 'datalogics_shipping')?><span></span></div>
                <div class="dso-con-box"> 
                </div>
            </div>
        </div>

        <div class="dso-modal dso-bulk-printing-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title"><?php echo __('Bulk Printing', 'datalogics_shipping')?><span></span></div>
                <div class="dso-con-box">
                </div>
            </div>
        </div>

        <div class="dso-modal dso-error-modal">
            <div class="dso-bg"></div>
            <div class="dso-con">
                <div class="dso-con-title"><?php echo __('Error', 'datalogics_shipping')?><span></span></div>
                <div class="dso-con-box">
                    <div class="dso-error-modal-box">
                    </div>
                </div>
            </div>
        </div>

        <?php
        
    }

}


add_action( 'wp_ajax_datalogics_get_datalogics_fields', 'datalogics_get_datalogics_fields' );

function datalogics_get_datalogics_fields() {

    $post_id = $_POST['order_id'];        
    $post = get_post($post_id);   
    datalogics_fields(1,$post); 
    wp_die();

}

add_action( 'wp_ajax_datalogics_get_bulk_cancel', 'datalogics_get_bulk_cancel' );

function datalogics_get_bulk_cancel() {

    $posts = explode(",",$_POST['orders']);
    ?>
    <div class="datalogics-bulk-shipping-box datalogics-cancel-box dsb-con">
        <div class="dso-con-table">
            <table>
                <tr>
                    <th><?php echo __('Name', 'datalogics_shipping')?></th>
                    <th><?php echo __('Destination', 'datalogics_shipping')?></th>
                    <th><?php echo __('Date', 'datalogics_shipping')?></th>
                    <th><?php echo __('Tracking Number', 'datalogics_shipping')?></th>
                    <th></th>
                </tr>
                <tbody>
                    <?php
                    foreach($posts as $post_id) {

                        if (!is_numeric($post_id)){
                            continue;
                        }

                        $tracking_number = '';

                        $post = get_post($post_id);  

                        $order = wc_get_order( $post->ID );
                        $order = $order->get_data();
                    
                        $email =  $order['billing']['email'];
                    
                        if ($order['shipping']['address_1']!='' && $order['shipping']['city']!='') {
                    
                            $address1 = $order['shipping']['address_1'];
                            $address2 = $order['shipping']['address_2'];
                            $city     = $order['shipping']['city'];
                            $phone    = $order['shipping']['phone'];
                            $fullname = $order['shipping']['first_name'] . ' ' .$order['shipping']['last_name']; 

                            if ($order['shipping']['phone']=='') {
                                $phone = $order['billing']['phone'];
                            }
                    
                        } else {
                    
                            $address1 = $order['billing']['address_1'];
                            $address2 = $order['billing']['address_2'];
                            $city     = $order['billing']['city'];
                            $phone    = $order['billing']['phone'];
                            $fullname = $order['billing']['first_name'] . ' ' .$order['billing']['last_name']; 
                    
                        }

                        $datalogics_shipping = get_post_meta( $post->ID, 'datalogics_shipping', true);                
                        if ($datalogics_shipping=='') 
                        {
                            $datalogics_shipping = [];
                        } else {
                            if (is_string($datalogics_shipping)) {  
                                $datalogics_shipping = json_decode($datalogics_shipping,true);
                            }
                        }                        

                        if (!empty($datalogics_shipping)) {
                            foreach($datalogics_shipping as $shipment) {        
                                $tracking_number    = $shipment['tracking_number'];
                            }
                        }


                        ?>
                        <tr data-order-id="<?php echo $post_id?>" data-tracking-number="<?php echo $tracking_number?>">
                            <td><?php echo $fullname?></td>
                            <td><?php echo $address1 .','.$address2 .','. $city; ?></td>
                            <td><?php echo date("d/m/Y H:i",strtotime($order['date_created']))?></td>
                            <td><?php echo $tracking_number?></td>
                            <td class="verified"></td>                            
                        </tr>
                        <?php
                
                    }
                    ?>
                </tbody>
            </table>
        </div>
        <div class="dso-con-ship-type">            
            <div class="dsb-box submit">
                <button type="button" class="datalogics_bulk cancel"><?php echo __('Cancel Orders', 'datalogics_shipping');?></button>
            </div>
        </div> 
    </div>
    <?php


    wp_die();

}

add_action( 'wp_ajax_datalogics_get_bulk_shipping', 'datalogics_get_bulk_shipping' );

function datalogics_get_bulk_shipping() {

    $posts = explode(",",$_POST['orders']);
    ?>
    <div class="datalogics-bulk-shipping-box datalogics-shipping-box dsb-con">
        <div class="dso-con-table">
            <table>
                <tr>
                    <th><?php echo __('Name', 'datalogics_shipping')?></th>
                    <th><?php echo __('Destination', 'datalogics_shipping')?></th>
                    <th><?php echo __('Date', 'datalogics_shipping')?></th>
                    <th></th>
                    <th></th>
                </tr>
                <tbody>
                    <?php
                    foreach($posts as $post_id) {

                        if (!is_numeric($post_id)){
                            continue;
                        }

                        $post = get_post($post_id);  

                        $order = wc_get_order( $post->ID );
                        $order = $order->get_data();
                    
                        $email =  $order['billing']['email'];
                    
                        if ($order['shipping']['address_1']!='' && $order['shipping']['city']!='') {
                    
                            $address1 = $order['shipping']['address_1'];
                            $address2 = $order['shipping']['address_2'];
                            $city     = $order['shipping']['city'];
                            $phone    = $order['shipping']['phone'];
                            $fullname = $order['shipping']['first_name'] . ' ' .$order['shipping']['last_name']; 

                            if ($order['shipping']['phone']=='') {
                                $phone = $order['billing']['phone'];
                            }
                    
                        } else {
                    
                            $address1 = $order['billing']['address_1'];
                            $address2 = $order['billing']['address_2'];
                            $city     = $order['billing']['city'];
                            $phone    = $order['billing']['phone'];
                            $fullname = $order['billing']['first_name'] . ' ' .$order['billing']['last_name']; 
                    
                        }


                        ?>
                        <tr data-order-id="<?php echo $post_id?>">
                            <td><?php echo $fullname?></td>
                            <td><?php echo $address1 .','.$address2 .','. $city; ?></td>
                            <td><?php echo date("d/m/Y H:i",strtotime($order['date_created']))?></td>
                            <td class="verified"></td>
                            <td>
                                <button type="button" class="dso-row-btn delete">
                                    <span><?php echo  __('Delete', 'datalogics_shipping'); ?>
                                </button>
                            </td>
                        </tr>
                        <?php
                
                    }
                    ?>
                </tbody>
            </table>
        </div>
        <div class="dso-con-subtitle"><?php echo __('Fill in the shipping details below to complete the order.', 'datalogics_shipping')?></div> 
        <div class="dso-con-ship-type">
            <div class="dsb-box">
                <?php echo __('Select they type of shipping', 'datalogics_shipping')?></label>
            </div>
            <?php
            $inventory_locations = get_option('datalogics_update_inventory_locations',''); 
            if ($inventory_locations!='') {
                if (is_string($inventory_locations)) {  
                    $inventory_locations = json_decode($inventory_locations,true);  
                }
                if (count($inventory_locations)>1) { 

                    ?>
                    <div class="dsb-box">
                        <div class="ncodelist">
                            <span class="datalogics-choosen-title"><?php echo __("Choose Inventory Location",'datalogics_shipping')?></span><br>
                            <select class="datalogics_location" id="datalogics_location">
                                <?php
                                foreach($inventory_locations as $key=>$location) {     
                                    if ($location['enable']!="true") {
                                        continue;
                                    }   
                                ?>
                                <option value="<?php echo $key?>"><?php echo $location['name']?></option>
                                <?php                                                                                                                                              
                                }
                                ?>
                            </select>
                        </div>
                    </div>
                    <?php                                
                }

            }
            /*
            ?>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_1" type="radio" value="1" name="datalogics_carrier_type" class="datalogics_carrier_type" checked>
                <label for="datalogics_carrier_type_1"><?php echo __('Delivery', 'datalogics_shipping')?></label>
            </div>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_2" type="radio" value="2" name="datalogics_carrier_type" class="datalogics_carrier_type">
                <label for="datalogics_carrier_type_2"><?php echo __('Pickup', 'datalogics_shipping')?></label>
            </div>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_3" type="radio" value="3" name="datalogics_carrier_type" class="datalogics_carrier_type">
                <label for="datalogics_type_3"><?php echo __('Transfer', 'datalogics_shipping')?></label>
            </div>
            */
            ?>
            <div class="dsb-box">
                <label for="datalogics_shipment_type"><?php echo __('Shipping Regular/Double', 'datalogics_shipping')?></label>
                <select id="datalogics_shipment_type" class="datalogics_shipment_type">
                    <option value="1" selected><?php echo __('Regular', 'datalogics_shipping')?></option>
                    <option value="2"><?php echo __('Double', 'datalogics_shipping')?></option>
                    <option value="3"><?php echo __('PickUp', 'datalogics_shipping')?></option>
                    <option value="4"><?php echo __('Govina', 'datalogics_shipping')?></option>
                </select>
            </div>
            <div class="dsb-box">
                <label for="datalogics_comment"><?php echo __('Comment', 'datalogics_shipping')?></label>
                <textarea id="datalogics_comment" class="datalogics_comment"></textarea>               
            </div>
            <div class="dsb-box submit">
                <button type="button" class="datalogics_bulk submit"><?php echo __('Send Orders', 'datalogics_shipping');?></button>
            </div>
        </div> 
    </div>
    <?php


    wp_die();

}

add_action( 'wp_ajax_datalogics_get_bulk_printing', 'datalogics_get_bulk_printing' );

function datalogics_get_bulk_printing() {

    $posts = explode(",",$_POST['orders']);
    $divide = $_POST['divide'];
    ?>
    <div class="datalogics-bulk-shipping-box datalogics-shipping-box dsb-con dsb-con-50">
        <div class="dso-con-table">
            <table>
                <tr>
                    <th><?php echo __('Name', 'datalogics_shipping')?></th>
                    <th><?php echo __('Destination', 'datalogics_shipping')?></th>
                    <th><?php echo __('Date', 'datalogics_shipping')?></th>
                    <th></th>
                    <th></th>
                </tr>
                <tbody>
                    <?php
                    foreach($posts as $post_id) {

                        if (!is_numeric($post_id)){
                            continue;
                        }

                        $post = get_post($post_id);  

                        $order = wc_get_order( $post->ID );
                        $order = $order->get_data();
                    
                        $email =  $order['billing']['email'];
                    
                        if ($order['shipping']['address_1']!='' && $order['shipping']['city']!='') {
                    
                            $address1 = $order['shipping']['address_1'];
                            $address2 = $order['shipping']['address_2'];
                            $city     = $order['shipping']['city'];
                            $phone    = $order['shipping']['phone'];
                            $fullname = $order['shipping']['first_name'] . ' ' .$order['shipping']['last_name']; 

                            if ($order['shipping']['phone']=='') {
                                $phone = $order['billing']['phone'];
                            }
                    
                        } else {
                    
                            $address1 = $order['billing']['address_1'];
                            $address2 = $order['billing']['address_2'];
                            $city     = $order['billing']['city'];
                            $phone    = $order['billing']['phone'];
                            $fullname = $order['billing']['first_name'] . ' ' .$order['billing']['last_name']; 
                    
                        }


                        ?>
                        <tr data-order-id="<?php echo $post_id?>">
                            <td><?php echo $fullname?></td>
                            <td><?php echo $address1 .','.$address2 .','. $city; ?></td>
                            <td><?php echo date("d/m/Y H:i",strtotime($order['date_created']))?></td>
                            <td class="verified"></td>
                            <td>
                                <button type="button" class="dso-row-btn delete">
                                    <span><?php echo  __('Delete', 'datalogics_shipping'); ?>
                                </button>
                            </td>
                        </tr>
                        <?php
                
                    }
                    ?>
                </tbody>
            </table>
        </div>
        <div class="dso-con-subtitle"><?php echo __('Fill in the shipping details below to complete the order.', 'datalogics_shipping')?></div> 
        <div class="dso-con-ship-type">
            <?php
            /*
            <div class="dsb-box">
                <?php echo __('Select they type of shipping', 'datalogics_shipping')?></label>
            </div>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_1" type="radio" value="1" name="datalogics_carrier_type" class="datalogics_carrier_type" checked>
                <label for="datalogics_carrier_type_1"><?php echo __('Delivery', 'datalogics_shipping')?></label>
            </div>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_2" type="radio" value="2" name="datalogics_carrier_type" class="datalogics_carrier_type">
                <label for="datalogics_carrier_type_2"><?php echo __('Pickup', 'datalogics_shipping')?></label>
            </div>
            <div class="dsb-box">
                <input id="datalogics_carrier_type_3" type="radio" value="3" name="datalogics_carrier_type" class="datalogics_carrier_type">
                <label for="datalogics_type_3"><?php echo __('Transfer', 'datalogics_shipping')?></label>
            </div>
            */
            ?>
            <div class="dsb-box">
                <label for="datalogics_shipment_type"><?php echo __('Shipping Regular/Double', 'datalogics_shipping')?></label>
                <select id="datalogics_shipment_type" class="datalogics_shipment_type">
                    <option value="1" selected><?php echo __('Regular', 'datalogics_shipping')?></option>
                    <option value="2"><?php echo __('Double', 'datalogics_shipping')?></option>
                    <option value="3"><?php echo __('PickUp', 'datalogics_shipping')?></option>
                    <option value="4"><?php echo __('Govina', 'datalogics_shipping')?></option>
                </select>
            </div>
            <div class="dsb-box">
                <label for="datalogics_comment"><?php echo __('Comment', 'datalogics_shipping')?></label>
                <textarea id="datalogics_comment" class="datalogics_comment"></textarea>               
            </div>
            <div class="dsb-box submit">
                <button type="button" class="datalogics_bulk submit"><?php echo __('Send Orders', 'datalogics_shipping');?></button>
            </div>
        </div> 
    </div>
    <?php


    wp_die();

}

function generatePDF($orders,$split) {


    foreach($orders as $order_id) {

        $post = get_post($order_id);  

        $order = wc_get_order( $post->ID );
        $order = $order->get_data();
    
        $email =  $order['billing']['email'];
    
        if ($order['shipping']['address_1']!='' && $order['shipping']['city']!='') {
    
            $address1 = $order['shipping']['address_1'];
            $address2 = $order['shipping']['address_2'];
            $city     = $order['shipping']['city'];
            $phone    = $order['shipping']['phone'];
            $fullname = $order['shipping']['first_name'] . ' ' .$order['shipping']['last_name']; 

            if ($order['shipping']['phone']=='') {
                $phone = $order['billing']['phone'];
            }
    
        } else {
    
            $address1 = $order['billing']['address_1'];
            $address2 = $order['billing']['address_2'];
            $city     = $order['billing']['city'];
            $phone    = $order['billing']['phone'];
            $fullname = $order['billing']['first_name'] . ' ' .$order['billing']['last_name']; 
    
        }


        ?>
        <div class="dsb-pdf">

            
            
        </div>
        <?php

    }


        


}



add_action( 'add_meta_boxes', 'datalogics_add_meta_boxes' );
if ( ! function_exists( 'datalogics_add_meta_boxes' ) )
{
    function datalogics_add_meta_boxes()
    {      
        global $post,$theorder, $datalogics_shipping_woo_page;   

        $id = '';
        if (is_object($post)) {
            $id = $post->ID;

        } else  if (is_object($theorder)) {
            $id = $theorder->get_id();

        } else if (isset($_GET['id'])){
            $id = $_GET['id'];

        } elseif (isset($_GET['post'])){
            $id = $_GET['post'];
        } 

        //var_dump('$datalogics_shipping_woo_page',$datalogics_shipping_woo_page,$id);
        
               
        if($datalogics_shipping_woo_page == 'edit') {

            $shipping_method = datalogics_check_allowed_shipping($id);
            if ($shipping_method == false) {
                return;
            }

            //add_meta_box('mv_other_fields1', __('DataLogics', 'datalogics_shipping') . ' ' . get_option('platform_name'), 'datalogics_fields', 'shop_order', 'side', 'core');
            $screen = wc_get_page_screen_id( 'shop-order' );
            add_meta_box('mv_other_fields2', __('DataLogics', 'datalogics_shipping') . ' ' . get_option('platform_name'), 'datalogics_fields', $screen , 'side', 'core');

            
            

        }
    }
}
if ( ! function_exists( 'datalogics_fields' ) )
{


    function datalogics_fields($title='',$post_data='')
    {

        global $post,$theorder;

        $order_data = '';

        
        
        if (is_object($theorder) && $theorder!='') {            
            $order_data = new stdClass;
            $order_data->ID = $theorder->get_id();        
        }

        if (is_object($post) && $post!='') {            
            $order_data = new stdClass;
            $order_data->ID = $post->ID;        
        }


        if ($post_data!='' && !is_array($post_data) ) {
            $order_data = $post_data;
        }

       

        // if ($post=='') {
        //     $post = $theorder;
        // }


        /*
         * LETS MAKE SURE THIS ORDER HAVE ALLOWED SHIPPING METHOD
         */

        

        $shipping_method = datalogics_check_allowed_shipping($order_data->ID);
        if ($shipping_method==false) {
            return;
        } 


        //Get existing data from DB (if exists)
        $datalogics_comment      = get_post_meta($order_data->ID, 'datalogics_comment', true) ? get_post_meta($order_data->ID, 'datalogics_comment', true) : '';
        // if ($datalogics_comment=='') {
            
        // }
        $datalogics_govina       = get_post_meta($order_data->ID, 'datalogics_govina', true) ? 'checked' : '';
        $datalogics_govina_sum   = get_post_meta($order_data->ID, 'datalogics_govina_sum', true) ? get_post_meta($order_data->ID, 'datalogics_govina_sum', true) : '';
        //$datalogics_shipping     = get_post_meta($post->ID, 'datalogics_shipping', true) ? get_post_meta($post->ID, 'datalogics_shipping', true) : '';
        //$datalogics_label        = get_post_meta($post->ID, 'datalogics_label_url', true) ? get_post_meta($post->ID, 'datalogics_label_url', true) : '';
        $datalogics_packages     = get_post_meta($order_data->ID, 'datalogics_packs', true) ? get_post_meta($order_data->ID, 'datalogics_packs', true) : '';
        if ($datalogics_packages=='') {
            $datalogics_packages = 1;
        }

        $ncode_platform_id = get_post_meta($order_data->ID, 'datalogics_n_code_platform_id',true);



        $datalogics_n_code = get_post_meta($order_data->ID, 'datalogics_n_code',true);

        //var_dump('$ncode_platform_id ',$ncode_platform_id ,'$datalogics_n_code',$datalogics_n_code);

        $ncode_ex = explode("-",$datalogics_n_code);   
        
        //var_dump($ncode_platform_id,$ncode_ex);
        
        //var_dump($ncode_ex);

        if (count($ncode_ex)==2) {
            $datalogics_n_code = $ncode_ex[1];
            $ncode_platform_id = $ncode_ex[0];
        }  

        $datalogics_inventory_location = get_post_meta($order_data->ID, 'datalogics_location',true);


        $datalogics_shipping = get_post_meta( $order_data->ID, 'datalogics_shipping', true);
                
        if ($datalogics_shipping=='') {

            $datalogics_shipping = [];

        } else {            

            if (!is_array($datalogics_shipping)) {

                $datalogics_shipping = json_decode($datalogics_shipping,true);

            }

        }



        $datalogics_api_key     = get_option('datalogics_api_key','');
        $datalogics_api_secret  = get_option('datalogics_api_secret','');


        


        $order = wc_get_order( $order_data->ID );
        $order = $order->get_data();

        $infoArray = datalogicsGetOrderInfo($order_data->ID );  
        foreach($infoArray as $key=>$value) {

            $$key = $value;

        }

        

        

        ?>   
        <div class="datalogics-shipping-box shipped" data-order-id="<?php echo $order_data->ID?>">  
        
            <div style="display:none" class="datalogics_loader"></div>
            
            <div class="dsb-logo">
                <?php if (DATALOGICS_COMPANY=='POSTIL') { ?>
                    <img src="<?php echo plugins_url( '/images/logos/postil.svg', __FILE__ );?>">
                <?php } else { ?>
                    <img src="<?php echo plugins_url( '/images/datalogics.svg', __FILE__ );?>">
                <?php } ?>
            </div>
            
            <div class="dsb-con">
            
                <div class="datalogics-shipping-exist">
                <?php
                //Echo shipping number if exists
                if (!empty($datalogics_shipping)) {

                    if (isset($datalogics_shipping['success'])) {

                        $shipment = $datalogics_shipping;

                    } else {

                        $shipment = end($datalogics_shipping);
                    }

                    $custom_label = get_option('datalogics_custom_label','');
                    if ($custom_label==1 || $shipment['label_url']=='') {
                        $shipment['label_url'] = DATALOGICS_PRINT_URL.''.$order_data->ID;
                    }


                    $label_url          = $shipment['label_url'];
                    $tracking_number    = $shipment['tracking_number'];
                    

                    if (isset($shipment['platform_name'])) {
                        $platform_name      = $shipment['platform_name'];
                    } else {
                        $platform_name = '';
                    }  
                    
                    
                    if (isset($shipment['location_name'])) {
                        $location_name      = $shipment['location_name'];
                    } else {
                        $location_name = '';
                    }  

                    if (!isset($shipment['platform_id'])) {
                        $shipment['platform_id'] = '';
                    }

                    $companies = get_option('datalogics_shipping_companies');
                    if ($companies=='') {                        
                        $companies = [];
                    } else if (is_string($companies)) {          

                        $companies = json_decode($companies,true);                    
                    }

                    foreach($companies as $platform_id=>$company_item) {
                        if ($platform_id==$shipment['platform_id']) {
                            $platform_name = $company_item['name'];
                        }
                    }

                    
                    ?>
                    <div class="datalogics-shipping-exist-box" data-order-id="<?php echo $order_data->ID?>">
                        <p class="datalogics-shipping-message">
                            <strong><?php echo __('Your order is ready for shipping', 'datalogics_shipping')?></strong>
                            <div class="dsb-sent-icon"></div>
                            <div class="dsb-shipping-comapny"><?php echo $platform_name?></div>
                            <div class="dsb-shipping-location"><?php echo $location_name?></div>
                            <div class="datalogics_tracking_number_label"><?php echo __('Your tracking number:', 'datalogics_shipping')?></div>
                            <div class="datalogics_tracking_number"><?php echo $tracking_number?></div>
                            <div class="dbs-barcode">
                                <?php
                                // $barcode_image = datalogicsCreateBarcode($tracking_number,'20','','code128');
                                ob_start();
                                $image = datalogicsCreateBarcode($tracking_number,'20','','code39');
                                imagepng($image);
                                // Capture the output and clear the output buffer
                                $imagedata = ob_get_clean();
                                ?>
                                <img src="data:image/png;base64,<?php echo base64_encode($imagedata)?>" />
                            </div>
                        </p>
                        <button class="datalogics_check_status"  type="button" data-tracking-number="<?php echo $tracking_number?>"><?php echo __('Check Shipment Status', 'datalogics_shipping');?></button>
                        <?php if ($label_url!='') {  ?>
                        <?php /*<button class="datalogics_submit download_label" type="button" data-label="<?php echo $label_url?>" data-tracking-number="<?php echo $tracking_number?>"><?php echo __('Download Label', 'datalogics_shipping');?></button>*/?>
                        <button class="datalogics_submit print_label" data-label="<?php echo $label_url?>" type="button" data-tracking-number="<?php echo $tracking_number?>"><?php echo __('Print Label', 'datalogics_shipping');?></button>
                        <?php } ?>
                        <button class="datalogics_submit cancel"  type="button" data-tracking-number="<?php echo $tracking_number?>"><?php echo __('Cancel Shipment', 'datalogics_shipping');?></button>
                        
                        <?php
                        if (DATALOGICS_COMPANY=='POSTIL') {
                        ?>
                        <div class="datalogics-print-notice">
                            <div><strong>הודעת תשובה:</strong></div>
                            <div>במידה והשידור התבצע (שעון ישראל) בימים א-ה בין השעות 00:01-12:00 (חצות עד 12 בצהריים) - האיסוף יתבצע היום עד שעה 16:00</div>
                            <div>במידה והאיסוף יתבצע בימים א-ה בין השעות 12:01-23:59 - האיסוף יתבצע מחר בין השעות 8:00-16:00.</div>
                            <div>במידה והשידור התבצע ביום חמישי חצות ועד מוצ"ש 23:50 - האיסוף יתבצע ביום ראשון בין השעות 8:00-16:00.</div>
                            <div> ניתן לעקוב אחר האיסוף או לבצע בו שינויים בפורטל השליחים</div>

                        </div>
                        <?php
                        }
                        ?>  
                        
                    </div>
                <?php
                    
                }
                ?>
                </div>
                <div class="datalogics-shipping-exist-box dupe" data-order-id="<?php echo $order_data->ID?>" style="display: none">
                    <p class="datalogics-shipping-message">
                        <strong><?php echo __('Your order is ready for shipping', 'datalogics_shipping')?></strong>
                        <div class="dsb-sent-icon"></div>
                        <div class="dsb-shipping-comapny"><?php echo $platform_name?></div>
                        <div class="dsb-shipping-location"><?php echo $location_name?></div>
                        <div class="datalogics_tracking_number_label"><?php echo __('Your tracking number:', 'datalogics_shipping')?></div>
                        <div class="datalogics_tracking_number"></div>
                        <div class="dbs-barcode">
                            <img src="<?php echo plugins_url("barcode.php", __FILE__ ) ?>?codetype=code39&size=20&text=">
                        </div>
                    </p>
                    <?php /*<button class="datalogics_submit download_label" type="button" data-label="" data-tracking-number=""><?php echo __('Download Label', 'datalogics_shipping');?></button>*/?>
                    <button class="datalogics_check_status"  type="button" data-tracking-number=""><?php echo __('Check Shipment Status', 'datalogics_shipping');?></button>
                    <button class="datalogics_submit print_label" type="button" data-label="" data-tracking-number=""><?php echo __('Print Label', 'datalogics_shipping');?></button>
                    <button class="datalogics_submit cancel"  type="button" data-tracking-number=""><?php echo __('Cancel Shipment', 'datalogics_shipping');?></button>
                </div>

                <?php                    
                $exist_companies = get_option('datalogics_shipping_method', ''); 
                if ($exist_companies=='') {                
                    ?>
                    <div class="dsb-shipping-box">
                        <a href="/wp-admin/admin.php?page=datalogics-settings"><?php echo __('Click Here to set your shipping companies', 'datalogics_shipping')?></a>
                    </div>
                    <?php
                } else {                

                    $exist_companies = json_decode($exist_companies,true);                        

                    $companies = get_option('datalogics_shipping_companies');
                    if ($companies=='') {
                        
                        $companies = [];

                    } else if (is_string($companies)) {  
                        
                        $companies = json_decode($companies,true);  
                        
                    }

                    ?>  
                    <div class="dsb-sender-box"<?php if (!empty($datalogics_shipping)) {?> style="display:none"<?php }?>>
                        <div class="dsb-box">                      
                            <label for="datalogics_shipping_method_<?php echo $order_data->ID?>"><?php echo __('Shipping Company', 'datalogics_shipping')?></label><br/>
                            <select class="datalogics_shipping_method_box" id="datalogics_shipping_method_<?php echo $order_data->ID?>" data-post-id="<?php echo $order_data->ID?>">
                            <?php  
                            $first_company = 0;  
                            foreach( $exist_companies as $shipping_company) {
                                foreach($companies as $platform_id=>$exist_company) {
                                    if ($platform_id==$shipping_company['shipping_push_supplier']) {

                                        if ($ncode_platform_id!='' && $ncode_platform_id!=$platform_id) {
                                            //continue;
                                        }

                                        if ($first_company==0) {
                                            $first_company = $platform_id;
                                        }

                                        ?>
                                        <option value="<?php echo $platform_id?>"><?php echo $exist_company['name']?></option>
                                        <?php

                                    }
                                }
                            }                        
                            ?>
                            </select>
                        </div>  
                        <?php 
                        foreach( $exist_companies as $shipping_company) {

                            if ($shipping_company['shipping_push_supplier']==52) {    // zigzag  
                                ?>
                                <div class="dsb-box">  
                                    <div class="zigzag-box" <?php if ($first_company!=52) { ?> style="display:none;" <?php } ?>>
                                        <div>
                                            <input type="radio" class="zigzag" name="user" id="datalogics-user1" value="<?php echo $shipping_company['shipping_push_supplier_username1']?>">
                                            <label for="datalogics-user1"><?php echo __("User 1",'datalogics_shipping')?> (<?php echo $shipping_company['shipping_push_supplier_username1']?>)</label>
                                        </div>
                                        <div>
                                            <input type="radio" class="zigzag" name="user" id="datalogics-user2" value="<?php echo $shipping_company['shipping_push_supplier_username2']?>">
                                            <label for="datalogics-user2"><?php echo __("User 2",'datalogics_shipping')?> (<?php echo $shipping_company['shipping_push_supplier_username2']?>)</label>
                                        </div>
                                        <div>
                                            <input type="radio" class="zigzag" name="user" id="datalogics-user3" value="<?php echo $shipping_company['shipping_push_supplier_username3']?>">
                                            <label for="datalogics-user3"><?php echo __("User 3",'datalogics_shipping')?> (<?php echo $shipping_company['shipping_push_supplier_username3']?>)</label>
                                        </div>
                                    </div>
                                </div>
                                <?php
                            }
                        }  
                        ?>                
                        <?php  
                        
                        $ncode_list = get_option('datalogics_shipping_locations');

                        if ($ncode_list!='' && !is_array($ncode_list)) {

                            //var_dump($locations_list);
    
                            $ncode_list = unserialize($ncode_list);

                        }

                        

                       
                        if (isset($ncode_list)) {  
                            $ncode_list_pass = false;
                            foreach ($ncode_list as $platform_id => $locations){ 
                                if (!empty($locations)) {
                                    $ncode_list_pass = true; 
                                    break; 
                                }
                            }
                            if ($ncode_list_pass==true) {

                            ?>
                            <div class="dsb-box">
                                <div class="ncodelist">
                                    <span class="datalogics-choosen-title">
                                        <?php echo __("Choose Pickup point",'datalogics_shipping')?>
                                        <?php 
                                        if ($datalogics_n_code!='') { 
                                            echo '('.$datalogics_n_code.')';
                                        }
                                        ?>
                                    </span><br>
                                    <select class="datalogics_n_code" id="datalogics_n_code_<?php echo $order_data->ID?>">
                                        <option value=""><?php echo __("Choose Pickup point",'datalogics_shipping')?></option>
                                        <?php
                                        foreach ($ncode_list as $platform_id => $locations){                                                        
                                            foreach ($locations as $values){
                                                ?>                                    
                                                <?php
                                                foreach($values as $value) {
                                                    ?>
                                                    <option <?php /*if($platform_id!=$ncode_platform_id) { */?>style="display:none;"<?php /*}*/ ?> data-platform-id="<?php echo $platform_id?>" value="<?php echo $value['n_code']?>" <?php if($value['n_code']==$datalogics_n_code && $platform_id==$ncode_platform_id) { ?>selected<?php } ?>><?php echo $value['city']?> - <?php echo $value['name']?>, <?php echo $value['street']?></option>
                                                    <?php
                                                }
                                                ?>                                    
                                                <?php
                                            }
                                        }
                                        ?>
                                    </select>
                                </div>
                            </div>
                            <?php
                            }
                        }
                        $inventory_locations = get_option('datalogics_update_inventory_locations',''); 
                        if ($inventory_locations!='') {

                            if (is_string($inventory_locations)) {                             
                                $inventory_locations = json_decode($inventory_locations,true);  
                            }
                            if (count($inventory_locations)>1) { 

                                ?>
                                <div class="dsb-box">
                                    <div class="ncodelist">
                                        <span class="datalogics-choosen-title"><?php echo __("Choose Inventory Location",'datalogics_shipping')?></span><br>
                                        <select class="datalogics_location" id="datalogics_location_<?php echo $order_data->ID?>">
                                            <?php
                                            foreach($inventory_locations as $key=>$location) {  
                                                if ($location['enable']!="true") {
                                                    continue;
                                                }   
                                            ?>
                                            <option value="<?php echo $key?>"<?php if ($datalogics_inventory_location==$key) { ?> selected <?php }?>><?php echo $location['name']?></option>
                                            <?php                                                                                                                                              
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                <?php                                
                            }

                        }
                        /*
                        ?>            
                        <div class="dsb-box">
                            <?php echo __('Select they type of shipping', 'datalogics_shipping')?></label>
                        </div>
                        <div class="dsb-box">
                            <input id="datalogics_carrier_type_1_<?php echo $post->ID?>" type="radio" value="1" name="datalogics_carrier_type_<?php echo $post->ID?>" class="datalogics_carrier_type" checked>
                            <label for="datalogics_carrier_type_1_<?php echo $post->ID?>"><?php echo __('Delivery', 'datalogics_shipping')?></label>
                        </div>
                        <div class="dsb-box">
                            <input id="datalogics_carrier_type_2_<?php echo $post->ID?>" type="radio" value="2" name="datalogics_carrier_type_<?php echo $post->ID?>" class="datalogics_carrier_type">
                            <label for="datalogics_carrier_type_2_<?php echo $post->ID?>"><?php echo __('Pickup', 'datalogics_shipping')?></label>
                        </div>
                        <div class="dsb-box">
                            <input id="datalogics_carrier_type_3_<?php echo $post->ID?>" type="radio" value="3" name="datalogics_carrier_type_<?php echo $post->ID?>" class="datalogics_carrier_type">
                            <label for="datalogics_type_3_<?php echo $post->ID?>"><?php echo __('Transfer', 'datalogics_shipping')?></label>
                        </div>
                        */
                        ?>
                        <div class="dsb-box">
                            <label for="datalogics_shipment_type_<?php echo $order_data->ID?>"><?php echo __('Shipping Regular/Double', 'datalogics_shipping')?></label>
                            <select id="datalogics_shipment_type_<?php echo $order_data->ID?>" class="datalogics_shipment_type">
                                <option value="1" selected><?php echo __('Regular', 'datalogics_shipping')?></option>
                                <option value="2"><?php echo __('Double', 'datalogics_shipping')?></option>
                                <option value="3"><?php echo __('PickUp', 'datalogics_shipping')?></option>
                                <option value="4"><?php echo __('Govina', 'datalogics_shipping')?></option>
                            </select>
                        </div>
                        <div class="dsb-box govina">
                            <label for="datalogics_govina_sum_<?php echo $order_data->ID?>"><?php echo __('Govina Sum', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_govina_sum_<?php echo $order_data->ID?>" class="datalogics_govina_sum">
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_packs_<?php echo $order_data->ID?>"><?php echo __('Number of Packages', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_packs_<?php echo $order_data->ID?>" class="datalogics_packs" value="<?php echo $datalogics_packages?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_fullname_<?php echo $order_data->ID?>"><?php echo __('Full Name', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_fullname_<?php echo $order_data->ID?>" class="datalogics_fullname" value="<?php echo (trim($fullname)!='') ? $fullname : $company;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_phone_<?php echo $order_data->ID?>"><?php echo __('phone', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_phone_<?php echo $order_data->ID?>" class="datalogics_phone" value="<?php echo $phone?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_city_<?php echo $order_data->ID?>"><?php echo __('City', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_city_<?php echo $order_data->ID?>" class="datalogics_city" value="<?php echo $city?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_address_<?php echo $order_data->ID?>"><?php echo __('Address', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_address_<?php echo $order_data->ID?>" class="datalogics_address" value="<?php echo $address1;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_house_<?php echo $order_data->ID?>"><?php echo __('House', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_house_<?php echo $order_data->ID?>" class="datalogics_house" value="<?php echo $address2;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_apartment_<?php echo $order_data->ID?>"><?php echo __('Apartment', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_apartment_<?php echo $order_data->ID?>" class="datalogics_apartment" value="<?php echo $apartment;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_floor_<?php echo $order_data->ID?>"><?php echo __('Floor', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_floor_<?php echo $order_data->ID?>" class="datalogics_floor" value="<?php echo $floor;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_entrance_<?php echo $order_data->ID?>"><?php echo __('Entrance', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_entrance_<?php echo $order_data->ID?>" class="datalogics_entrance" value="<?php echo $entrance;?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_email_<?php echo $order_data->ID?>"><?php echo __('email', 'datalogics_shipping')?></label>
                            <input type="text" id="datalogics_email_<?php echo $order_data->ID?>" class="datalogics_email" value="<?php echo $email?>" >
                        </div>
                        <div class="dsb-box">
                            <label for="datalogics_comment_<?php echo $order_data->ID?>"><?php echo __('Comment', 'datalogics_shipping')?></label>
                            <textarea id="datalogics_comment_<?php echo $order_data->ID?>" class="datalogics_comment"><?php echo $datalogics_comment?></textarea>               
                        </div>
                        <div class="dsb-box submit">
                            <button id="datalogics_submit_<?php echo $order_data->ID?>" type="button" class="datalogics_submit submit"><?php echo __('Send', 'datalogics_shipping');?></button>
                        </div>

                        <div class="datalogics_error"></div>

                    </div>
                <?php 
                }
                ?>
            </div>
        </div>      

     
        <?php



    }
}


if (!function_exists('datalogics_orders_column'))
{

    function datalogics_orders_column($columns)
    {
       
        $new_columns = array();
        foreach ($columns as $column_name => $column_info)
        {
            
            $new_columns[$column_name] = $column_info;
            if ('order_total' === $column_name)
            {
                $custom_label = get_option('datalogics_custom_label','');
                $column_content = 'Datalogics shipping';
                $new_columns['datalogics_column'] = '<img src="'.plugins_url( '/images/datalogics.svg', __FILE__ ).'">'; //__($column_content, 'datalogics_shipping');
                $new_columns['datalogics_column'] = '
                            <button type="button" class="datalogics-bulk send">
                                <span>' . __('Bulk Shipments', 'datalogics_shipping'). '
                            </button> 
                            '. (($custom_label==1) ? '<button type="button" class="datalogics-bulk print">
                               ' . __('Bulk print Labels', 'datalogics_shipping'). '
                            </button>' : '') .'
                            <button type="button" class="datalogics-bulk cancel">
                                ' . __('Bulk cancel Shipments', 'datalogics_shipping'). '
                            </button> 
                ';
            }
        }

        return $new_columns;
    }
    add_filter('manage_edit-shop_order_columns', 'datalogics_orders_column', 20);
    add_filter( 'manage_woocommerce_page_wc-orders_columns', 'datalogics_orders_column' );
    //add_filter('woocommerce_shop_order_columns', 'datalogics_orders_column', 10);
}

if (!function_exists('datalogics_orders_column_populate')) {

    function datalogics_orders_column_populate_hpos($column,$order) {
        datalogics_orders_column_populate($column,$order);
    }
    function datalogics_orders_column_populate_legacy($column) {
        global $post;
        datalogics_orders_column_populate($column,$post);
    }

    function datalogics_orders_column_populate($column,$post)
    {

         
        

        $shipping_method = datalogics_check_allowed_shipping($post->ID);
        if ($shipping_method == false) {
            return;
        }

        //$order = wc_get_order($post->ID);

        if ('datalogics_column' === $column) {

            //FIX FOR VERSION 1 START
            $label_url = get_post_meta($post->ID, 'datalogics_label_url', true);
            if ($label_url!='') {

                $tracking_number = get_post_meta($post->ID, 'datalogics_shipping', true);

                $datalogics_shipping = [
                    [
                        'label_url' =>  $label_url,
                        'tracking_number'=> $tracking_number
                    ]
                ];

                $datalogics_shipping = json_encode($datalogics_shipping);

                update_post_meta($post->ID, 'datalogics_label_url', '');
                update_post_meta($post->ID, 'datalogics_shipping', $datalogics_shipping);

            }
            //FIX FOR VERSION 1 END

            $datalogics_shipping = get_post_meta($post->ID, 'datalogics_shipping', true);
            if ($datalogics_shipping=='') {
                $datalogics_shipping = [];
            } else {
                if (is_string($datalogics_shipping)) {  
                    $datalogics_shipping = json_decode($datalogics_shipping,true);
                }
            }
            ?>
            <div class="datalogics-orders-colum" data-order-id="<?php echo $post->ID?>"> 
                
                <div class="datalogics-shipping-orders-container dupe" style="display:none">
                    <button type="button" class="dso-row-btn send">
                        <span><?php echo __('Send Shipment', 'datalogics_shipping')?></span>
                    </button>
                    <button type="button" class="dso-row-btn edit">
                        <span><?php echo __('Edit Shipment', 'datalogics_shipping')?></span>
                    </button>
                    <span class="dso-row-method"><?php echo $shipping_method?></span>  
                    <span class="dso-row-tracking-number"></span>                                      
                    <button type="button" class="dso-row-btn print" data-label="">
                        <span><?php echo __('Print Shipment', 'datalogics_shipping')?></span>
                    </button> 
                    <button type="button" class="dso-row-btn status" data-order-id="<?php echo $post->ID?>">
                        <span><?php echo __('Status Shipment', 'datalogics_shipping')?></span>
                    </button>
                    <button type="button" class="dso-row-btn cancel" data-tracking-number="">
                        <span><?php echo __('Cancel', 'datalogics_shipping')?></span>
                    </button>                    
                </div>               
                <?php
                if (!empty($datalogics_shipping)) {

                    if (isset($datalogics_shipping['success'])) {

                        $shipment = $datalogics_shipping;

                    } else {

                        if (is_array($datalogics_shipping)) {

                            $shipment = end($datalogics_shipping);

                        } else {
                            $shipment = [];
                        }
                    }


                    $custom_label = get_option('datalogics_custom_label','');
                    if ($custom_label==1 || $shipment['label_url']=='') {
                        $shipment['label_url'] = DATALOGICS_PRINT_URL.''.$post->ID;
                    }

                    
                    ?>
                        <div class="datalogics-shipping-orders-container">
                            <span class="dso-row-tracking-number"><?php echo $shipment['tracking_number']?></span>                                      
                            <button type="button" class="dso-row-btn print" data-label="<?php echo ($shipment['label_url']!='') ? $shipment['label_url'] : '';?>">
                                <span><?php echo __('Print Shipment', 'datalogics_shipping')?></span>
                            </button> 
                            <button type="button" class="dso-row-btn cancel" data-tracking-number="<?php echo $shipment['tracking_number']?>">
                                <span><?php echo __('Cancel', 'datalogics_shipping')?></span>
                            </button>      
                            <button type="button" class="dso-row-btn status" data-order-id="<?php echo $post->ID?>">
                                <span><?php echo __('Status Shipment', 'datalogics_shipping')?></span>
                            </button>                                       
                        </div>
                    <?php
                    
                } else {
                    ?>
                    <div class="datalogics-shipping-orders-container">
                        <button type="button" class="dso-row-btn send">
                            <span><?php echo __('Send Shipment', 'datalogics_shipping')?></span>
                        </button>
                        <button type="button" class="dso-row-btn edit">
                            <span><?php echo __('Edit Shipment', 'datalogics_shipping')?></span>
                        </button>
                        <span class="dso-row-method"><?php echo $shipping_method?></span>                   
                    </div>
                    <?php 
                }
                ?>                
            </div>
            <?php
        }
    }
    add_action('manage_shop_order_posts_custom_column', 'datalogics_orders_column_populate_legacy');
    add_action('manage_woocommerce_page_wc-orders_custom_column', 'datalogics_orders_column_populate_hpos', 10, 2);
}

function datalogics_check_allowed_shipping($order_id){

    $passed = false;

    $datalogics_shipping_options_enabled = get_option('datalogics_shipping_options_enabled','');

    if ($datalogics_shipping_options_enabled=="true" || $datalogics_shipping_options_enabled==1) {
        
        $datalogics_shipping_options_enabled = 1;

    } else {
        $datalogics_shipping_options_enabled = 0;
    }

    $current_shipping_options = get_option('datalogics_shipping_options', '');
    if ($current_shipping_options=='') {
        $current_shipping_options = [];
    } else {
        if (is_string($current_shipping_options)) {  
            $current_shipping_options = json_decode($current_shipping_options);
        }
    }

    /*?>
    // <div class="talhide" style="display: none;"><?php var_dump($current_shipping_options)?></div>
    // <?php
    */

    $order = wc_get_order($order_id);

    $shipping_method_title =  $order->get_items( 'shipping' );
    foreach($shipping_method_title as $v) {

        if ($datalogics_shipping_options_enabled==1) {

            if (in_array($v['method_id'], $current_shipping_options)) {
                $passed = $v['method_title'];
            }

        } else {

            $passed = $v['method_title'];

        }

    }

    if ($passed==false && $datalogics_shipping_options_enabled!=1) {
        return __('No shipping method selected','datalogics_shipping');
    }


    return $passed;

}



add_action( 'wp_ajax_datalogics_check_order_shipping_status', 'datalogics_check_order_shipping_status' );

function datalogics_check_order_shipping_status() {

    $order_id   = $_POST['order_id'];

    //$order                  = wc_get_order( $order_id );
    //$order_data             = $order->get_data();
    $datalogics_shipping    = get_post_meta( $order_id, 'datalogics_shipping', true );
           
    if ($datalogics_shipping!='') {

        $datalogics_shipping = json_decode($datalogics_shipping,true);

        $_POST['order_no'] = $order_id;
        $_POST['shipping_no'] = $datalogics_shipping['tracking_number'];

        $data = datalogics_track_shipping($returnJsonData=false);

        ?>
        <div class="datalogics-status-shipping-box datalogics-shipping-box dsb-con">
        <?php
        foreach($data['status'] as $status) {
            ?>        
            <div class="dsb-con-status">
                <div><?php echo $status['date'];?></div>
                <div><?php echo $status['status'];?></div>
            </div>
            <?php
        }     
        ?>
        </div>
        <?php

    }    

    die;

}
