<!DOCTYPE html>
<html lang="he">
<head>
    <meta charset="utf-8">
    <meta http-equiv="Content-type" content="text/html; charset=UTF-8">

    <link href="https://fonts.googleapis.com/css2?family=Heebo:wght@300;400&display=swap" rel="stylesheet">

    <style type="text/css">
        @page {
            size: 10cm 10cm;
            margin: 0;
            padding: 0;
            direction: rtl;
        }

        /* html {
            overflow: hidden;
        } */

        body {
            direction: rtl;                
            font-family:  Heebo, DejaVu Sans, monospace;
            /* font-family: Arial; */
            width: 10cm;
            height: 10cm;    
            overflow: hidden;
            margin:0;
            /* border: 1px solid #000; */
            /* unicode-bidi: bidi-override; */
        }

        body .table {
            width: 100%;
            margin: auto;
            page-break-after: always;
            width: 10cm;
            height: 10cm;
            overflow: hidden;
        }

        .top {
            display: flex;
            justify-content: space-between;
        }

        .barcode {
            direction : rtl;
            color: #000;
            text-align: center;
            padding-top:3px;
        }

        .barcode img {
            width: 300px;
            height: 35px;
            margin-top: 5px;
        }

        .barcode_image {
        }

        .barcode_number {
            font-size: 14px;
            letter-spacing: 10px;
        }

        .location {
            display: flex;
            justify-content: space-between;
            border-top: 1px solid #000;
            padding: 10px 0;
            text-align: center;
            font-size: 14px;
        }

        .row {
            display: flex;
            justify-content: space-between;
            border-bottom: 1px solid #000;
            padding-bottom: 2px;
            text-align: center;
            font-size: 13px;
        }

        .location > div {
            flex: 1;
            border-left: 1px solid #000;
        }

        .location > div:last-child {
            border-left:0;
        }

        .package_type {
            border-top: 1px solid #000;
            padding: 0 10px;
        }

        .details {
            border-top: 1px solid #000;
        }  
        
        
        .logo {        
            width: 90px;
            background-size: 100%;
            background-repeat: no-repeat;
            background-position: center;
        }

        <?php
        if (in_array($datalogics_platform_id,[61,62,63])) {
            if ($ncode!='') {
                $delivery_logo = CD_PLUGIN_PATH.'images/logos/click2post_min.jpg';        
            } else {        
                $delivery_logo = CD_PLUGIN_PATH.'images/logos/postil.jpg';
            }
            ?>
            .logo {
                background-image: url(<?php echo datalogics_convert_base64($delivery_logo)?>);
            }
            <?php
        }
        ?>

        .logo img {
            width:100%;
        }

        .logo_company {
            background-image: url('<?php echo $custom_logo?>');
            width: 90px;
            background-size: 68%;
            background-repeat: no-repeat;
            background-position: center;
        }
        .logo_company img {
            width:100%;
        }

        /* .top {
            height:100px;
        }

        .row {
            margin-top: 100px;
            height: 100px;;
        } */

        .origin,
        .destination {
            display: flex;
            justify-content: space-between;
            font-size:14px;            
        }

        .origin {
            border-bottom:1px solid #000;
            padding:5px 0;
        }

        .destination {
            border-top:1px solid #000;
            padding:5px 0;
            padding-bottom:0;
            border-bottom:0;
        }
        .shipping_type {
            font-size:13px;
            padding-bottom: 2px;
        }

        .print {
            background: #000;
            color: #fff;
            text-align: center;
            border-radius: 5px;
            margin-top: 10px;
            padding: 9px;
            cursor: pointer;
            position: fixed;
            bottom:10px;
            left:10px
        }

        @media print {
            .print {
                display: none;
            }
        }



    </style>        
</head>
<body>
<table class="table">
    <tr>
        <td>
            <div class="container">
                <div class="row">
                    <div class="type">מספר הזמנה: <?php echo $order_id?></div>
                    <?php if ($line!='') {
                        ?>
                        <div class="line">קו: <?php echo $line?></div>
                        <?php
                    }
                    ?>
                    <div class="date">
                        <?php echo date("H:i d/m/Y",strtotime($order->date_created))?>
                    </div>
                </div>
                <div class="origin">
                    <div class="from">
                        <!-- <div class="contract_number">
                            <span>מספר המנוי</span>:
                            <span><?php echo $contract_number?></span>
                        </div> -->
                        <div class="name">
                            <span>שם השולח</span>:
                            <span><?php echo $origin_fullname?> (<?php echo $contract_number?>)</span>                            
                        </div>
                        <div class="address">
                            <span>כתובת השולח</span>:
                            <span><?php echo $origin_address?></span>
                        </div>
                        <div class="phone">
                            <span>טלפון</span>:
                            <span><?php echo $origin_phone?></span>                            
                        </div>
                    </div>
                    <div class="border"></div>
                    <div class="logo_company"></div>   
                </div>
                <div class="barcode">
                    <?php
                    //var_dump(CD_PLUGIN_PATH.'barcode.php');
                    //include_once CD_PLUGIN_PATH.'vendor/barcode.php';
                    //include_once 'barcode.php';
                    ob_start();
                    $image = datalogicsCreateBarcode($barcode,'20','','code128');
                    imagepng($image);
                    // Capture the output and clear the output buffer
                    $imagedata = ob_get_clean();
                    ?>
                    <div class="barcode_image">
                        <img src="data:image/png;base64,<?php echo base64_encode($imagedata)?>" />
                    </div>
                    <div class="barcode_number">
                        <?php echo $barcode?>
                    </div>
                    <div class="shipping_type">
                    <?php if ($ncode=='') {?>דואר שליחים<?php } else { ?>נקודת מסירה - <?php echo $ncode?> - <?php echo $ncode_name?><?php } ?>
                    </div>
                </div>
                <div class="destination">
                    <div class="to">
                        <div class="name">
                            <span>שם הנמען</span>:
                            <span><?php echo $destination_fullname?></span>
                        </div>
                        <div class="address">
                            <span><?php if ($ncode=='') {?>כתובת הנמען<?php } else { ?>כתובת מרכז המסירה<?php } ?></span>:
                            <span><?php echo $destination_address?></span>
                        </div>
                        <div class="city">
                            <span>שם הישוב</span>:
                            <span><?php echo $destination_city?></span>                         
                        </div>                        
                        <div class="phone">
                            <span>טלפון</span>:
                            <span><?php echo $destination_phone?></span>                                                 
                        </div>
                        <div class="notes">
                            <span>הערות</span>:
                            <span><?php echo $notes?></span>
                            <?php 
                            if ($products_in_comments==true && !empty($items)) {
                                ?>
                                <?php
                                echo implode(",",$items); 
                                ?>
                                <?php
                            }
                            ?>    
                        </div>
                    </div>
                    <div class="border"></div>
                    <div class="logo"></div> 
                </div>                
                
                <?php
                /*
                foreach( $order->get_items() as $item_id => $item )
                {
                    
                }
                                           
                <div class="details">
                    
                </div>
                <div class="bottom"></div>
                */
                ?>
                <div class="print" onclick="window.print()"><?php echo __('Print Label','datalogics_shipping')?></div>
            </div>
        </td>
    </tr>
</table>
</body>
</html>