<!DOCTYPE html>
<html lang="he">
<head>
    <meta charset="utf-8">
    <meta http-equiv="Content-type" content="text/html; charset=UTF-8">

    <link href="https://fonts.googleapis.com/css2?family=Heebo:wght@300;400&display=swap" rel="stylesheet">


    <style type="text/css">
        @page {
            size: 10cm 10cm;
            margin: 0;
            padding: 0;
            direction: rtl;            
        }
        /* html {
            overflow: hidden;
        } */

        body {
            direction: rtl;                
            font-family:  Heebo, DejaVu Sans, monospace;
            /* font-family: Arial; */
            width: 10cm;
            height: 10cm;
            overflow: hidden;
            margin:0;
            /* border: 1px solid #000; */
            /* unicode-bidi: bidi-override; */
            
        }

        body .table {
            width: 100%;
            margin: auto;
            page-break-after: always;
            width: 10cm;
            height: 10cm;
            overflow: hidden;
        }

        .top {
            display: flex;
            justify-content: space-between;
        }

        .barcode {
            direction : rtl;
            color: #000;
            text-align: center;
            padding-top:3px;
        }

        .barcode img {
            width: 220px;
            height: 38px;
            margin-top: 0px;
        }

        .barcode_image {
        }

        .barcode_number {
            font-size: 14px;
            letter-spacing: 2px;
        }

        .location {
            display: flex;
            justify-content: space-between;
            border-top: 1px solid #000;
            padding: 10px 0;
            text-align: center;
            font-size: 14px;
        }

        .row {
            display: flex;
            justify-content: space-between;
            border-bottom: 2px solid #000;
            text-align: center;
            font-size: 13px;
        }

        .location > div {
            flex: 1;
            border-left: 1px solid #000;
        }

        .location > div:last-child {
            border-left:0;
        }

        .package_type {
            border-top: 1px solid #000;
            padding: 0 10px;
        }

        .details {
            /* border-top: 1px solid #000; */
            font-size:13px;
            flex-grow: 1;
        }  

        .details ul{
            margin:0;
            padding:0;
            list-style: disc;
        }
        .details li{
            margin-right:20px;
        }       
        
        .logo {        
            width: 90px;
            background-size: 100%;
            background-repeat: no-repeat;
            background-position: center;
        }

        <?php
        if (in_array($datalogics_platform_id,[61,62,63])) {
            if ($ncode!='') {
                $delivery_logo = 'images/logos/click2post_min.jpg';        
            } else {        
                $delivery_logo = 'images/logos/postil.jpg';
            }
            ?>
            .logo {
                background-image: url(<?php echo datalogics_convert_base64($delivery_logo)?>);
            }
            <?php
        }
        ?>

        .logo img {
            width:100%;
        }

        .logo_company {
            background-image: url('<?php echo $custom_logo?>');
            width: 100%;
            height: 100%;
            background-size: 100%;
            background-repeat: no-repeat;
            background-position: center;
        }
        .logo_company img {
            width:100%;
        }

        /* .top {
            height:100px;
        }

        .row {
            margin-top: 100px;
            height: 100px;;
        } */

        .row-addresses {
            border-bottom:2px solid #000;
        }

        .origin,
        .destination {
            display: flex;
            justify-content: space-between;
            font-size:13px;   
            flex:1;         
            text-align: right;;
            padding:2px 0;
        }


        .destination {     
        }
        .shipping_type {
            font-size:13px;
            padding-bottom: 2px;
        }

        .top-details {
            padding-top:3px;
        }

        .row-bottom {
            display: flex;
            flex-grow: 1;
        }
        .logo-bottom {
            width:90px;
            min-height: 90px;;
            margin-right:10px;
        }

        .print {
            background: #000;
            color: #fff;
            text-align: center;
            border-radius: 5px;
            margin-top: 10px;
            padding: 9px;
            cursor: pointer;
            position: fixed;
            bottom:10px;
            left:10px
        }

        .line-box {
            width: 70px;
            min-height: 40px;
            margin-right: 10px;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 25px;
            font-weight: bold;
            border: 2px solid #000;
            margin-top: 10px;
        }
        .top-details {
            margin-right: 10px;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 38px;
            font-weight: bold;
            border: 2px solid #000;
            margin-top: 1px;
            padding: 0 20px;
            height: 40px;
        }

        @media print {
            .print {
                display: none;
            }
        }



    </style>        
</head>
<body>
<table class="table">
    <tr>
        <td>
            <div class="container">
                <div class="row row-top">    
                    <div class="barcode">
                        <?php
                        //var_dump(CD_PLUGIN_PATH.'barcode.php');
                        //include_once CD_PLUGIN_PATH.'vendor/barcode.php';
                        //include_once 'barcode.php';
                        ob_start();
                        $image = datalogicsCreateBarcode($barcode,'20','','code128');
                        imagepng($image);
                        // Capture the output and clear the output buffer
                        $imagedata = ob_get_clean();
                        ?>
                        <div class="barcode_image">
                            <img src="data:image/png;base64,<?php echo base64_encode($imagedata)?>" />
                        </div>
                        <div class="barcode_number">
                            <?php echo $barcode?>
                        </div>
                        <div class="shipping_type">
                        <?php if ($ncode=='') {?>שליח עד הבית<?php } else { ?>נקודת מסירה - <?php echo $ncode?> - <?php echo $ncode_name?><?php } ?>
                        </div>
                    </div>
                    <div class="top-details">
                        <?php                         
                        if ($area!='') {
                            ?>
                            <div class="line"><?php echo $area?></div>
                            <?php
                        }
                        ?>                                           
                    </div>
                </div>
                <div class="row">
                    <div class="date">
                        <?php echo date("H:i d/m/Y",strtotime($order->date_created))?>
                    </div>
                    <div>
                        <?php 
                        if ($shipment_type!='') {
                            ?>
                            סוג:
                            <?php
                            if ($shipment_type==1) {
                                ?>
                                <span>משלוח רגיל</span>
                                <?php
                            }
                            if ($shipment_type==2) {
                                ?>
                                <span>משלוח כפולה</span>
                                <?php
                            }
                            if ($shipment_type==3) {
                                ?>
                                <span>משלוח איסוף</span>
                                <?php
                            }
                            if ($shipment_type==4) {
                                ?>
                                <span>משלוח  גובינה</span>
                                <?php
                            }
                        }
                        ?>
                    </div>
                    <div class="type">מספר הזמנה: <?php echo $order_id?></div>                    
                </div>
                <div class="row row-addresses">
                    <div class="origin">
                        <div class="from">
                            <div class="contract_number">
                                <span>מאת</span>:
                                <span><?php echo $origin_fullname?></span>
                            </div>                            
                        </div>  
                    </div>
                </div>
                <div class="row row-addresses">
                    <div class="destination">
                        <div class="to">
                            <div class="name">
                                <strong>עבור</strong>:
                                <span><?php echo $destination_fullname?></span>
                                ,<strong><?php if ($ncode=='') {?>כתובת הנמען<?php } else { ?>נקודת המסירה<?php } ?></strong>
                                <span><?php echo $destination_address?></span>
                                ,<strong>עיר</strong>:
                                <span><?php echo $destination_city?></span>                         
                                ,<strong>טלפון</strong>:
                                <span><?php echo $destination_phone?></span>                                                 
                            </div>                            
                        </div>
                    </div>
                </div>
                <div class="row row-addresses">
                    <div class="notes">
                        <span>הערות</span>:
                        <span><?php echo $notes?></span>    
                    </div>
                </div>  
                <?php
                ?>   
                <div class="row-bottom">                                        
                    <div class="details">
                        <?php 
                        if ($products_in_comments==true && !empty($items)) {
                            ?>
                            <div class="products_list">רשימת מוצרים:</div>
                            <ul>
                                <li>
                                <?php
                                echo implode("</li><li>",$items); 
                                ?>
                                </li>
                            </ul>
                            <?php
                        }
                        ?>
                        <?php //echo $comments?>
                    </div>                    
                    <?php                         
                    //if ($line!='') {
                        ?>
                        <div class="logo-bottom line-box">
                            <div class="line"><?php echo $line?></div>
                        </div>
                        <?php
                    //}
                    ?>
                </div>
                <div class="print" onclick="window.print()"><?php echo __('Print Label','datalogics_shipping')?></div>
            </div>
        </td>
    </tr>
</table>
</body>
</html>