<!DOCTYPE html>
<html lang="he">
<head>
    <meta charset="utf-8">
    <meta http-equiv="Content-type" content="text/html; charset=UTF-8">

    <link href="https://fonts.googleapis.com/css2?family=Heebo:wght@300;400&display=swap" rel="stylesheet">

    <style type="text/css">
        @page {
            size: 10cm 10cm;
            margin: 0;
            padding: 0;
            direction: rtl;
        }

        body {
            direction: rtl;                
            font-family:  Heebo, DejaVu Sans, monospace;
            /* font-family: Arial; */
            width: 10cm;
            height: 10cm;
            /* border: 1px solid #000; */
            /* unicode-bidi: bidi-override; */
        }

        body .table {
            width: 100%;
            margin: auto;
        }

        .top {
            display: flex;
            justify-content: space-between;
        }

        .barcode {
            direction : rtl;
            color: #000;
            text-align: center;
        }

        .barcode img {
            width: 193px;
            height: 50px;
            margin-top: 5px;
        }

        .barcode_image {
        }

        .barcode_number {
            font-size: 14px;
            padding-bottom: 6px;
        }

        .location {
            display: flex;
            justify-content: space-between;
            border-top: 1px solid #000;
            padding: 10px 0;
            text-align: center;
            font-size: 14px;
        }

        .row {
            display: flex;
            justify-content: space-between;
            border-top: 1px solid #000;
            padding: 3px 0 1px;
            text-align: center;
            font-size: 13px;
        }

        .location > div {
            flex: 1;
            border-left: 1px solid #000;
        }

        .location > div:last-child {
            border-left:0;
        }

        .package_type {
            border-top: 1px solid #000;
            padding: 0 10px;
        }

        .details {
            border-top: 1px solid #000;
        }

        .logo {
            background-image: url(<?php echo datalogics_convert_base64('images/logos/postil.jpg')?>);
            width: 90px;
            height: 66px;;
            background-size: 100%;
            background-repeat: no-repeat;
            background-position: center;
        }

        .logo img {
            width:100%;
        }

        .logo_company {
            background-image: url(<?php echo datalogics_convert_base64('images/logos/14-300x241.jpg')?>);
            width: 90px;
            background-size: 68%;
            background-repeat: no-repeat;
            background-position: center;
            height: 52px;
            margin-top: 5px;
        }
        .logo_company img {
            width:100%;
        }

        /* .top {
            height:100px;
        }

        .row {
            margin-top: 100px;
            height: 100px;;
        } */



    </style>        
</head>
<body>
<table class="table">
    <tr>
        <td>
            <div class="container">                    
                <div class="top">
                    <div class="logo"></div>                    
                    <div class="barcode">
                        <?php
                        //var_dump(CD_PLUGIN_PATH.'barcode.php');
                        ///include_once CD_PLUGIN_PATH.'vendor/barcode.php';
                        //include_once 'barcode.php';
                        ob_start();
                        $image = datalogicsCreateBarcode($barcode,'20','','code39');
                        imagepng($image);
                        // Capture the output and clear the output buffer
                        $imagedata = ob_get_clean();
                        ?>
                        <div class="barcode_image">
                            <img src="data:image/png;base64,<?php echo base64_encode($imagedata)?>" />
                        </div>
                        <div class="barcode_number">
                            <?php echo $barcode?>
                        </div>
                    </div>
                    <div class="logo_company"></div> 
                </div>
                <div class="row">
                    <div class="type"><?php if ($ncode=='') {?>חבילה רגילה<?php } else { ?>נקודת מסירה - <?php echo $ncode?><?php } ?></div>
                    <div class="date"><?php echo date("H:i d/m/Y",strtotime($order->date_created))?></div>
                </div>
                
                <?php
                /*
                foreach( $order->get_items() as $item_id => $item )
                {
                    
                }
                */
                ?>
                <div class="location">
                    <div class="from">
                        <div><strong><?php echo ('מוען')?></strong></div>
                        <div class="name">ביוטיקייר</div>
                        <div class="phone">03-995-0212</div>                            
                        <div>איזור תעשיה בני דרום</div>
                    </div>
                    <div class="to">
                        <div><strong>נמען</strong></div>
                        <div class="name"><?php echo $fullname?></div>
                        <div class="phone"><?php echo $phone?></div>                            
                        <div><?php echo $address?></div>
                        
                    </div>
                </div>                     
                <div class="details">
                    
                </div>
                <div class="bottom"></div>
            </div>
        </td>
    </tr>
</table>
</body>
</html>