<?php
/*
 * Be very careful were you place wp_enqueue_style and wp_enqueue_script.
 * If you write those two functions in the beginning of an administration
 * page (eg: main-page-empty-plugin.php) you include the CSS and the JS
 * file only in that administration page.
 * But if you write those two functions in the main plugin file you will
 * include the CSS/JS file in all the pages of your website.
 */
// loading the CSS
// loading the JS

//wp_enqueue_style('datalogics-style', plugins_url( '/css/style.css', __FILE__ ) );
wp_enqueue_style('datalogics-style', add_query_arg( DATALOGICS_ARGS,plugins_url('/css/style_admin.css', __FILE__)));
wp_enqueue_script('datalogics-settings-script', add_query_arg( DATALOGICS_ARGS,plugins_url('/js/settings.js', __FILE__)));
wp_localize_script('datalogics-settings-script', 'object_data_settings', array('ajax_url' => admin_url('admin-ajax.php'),"settings_error" => __('Error: All fields must be filled!', 'datalogics_shipping')));

$datalogics_url_section = (isset($_GET) && isset($_GET['section'])) ? $_GET['section'] : '';

function getLocationHtmlBox($location,$key,$hidden='') {
    ob_start();
    ?>
    <div class="dsp-location-box<?php if ($hidden!='') {?> dsp-location-box-hidden<?php } ?>">
        <div class="dsp-location-box-top">    
            <div>
                <div class="dsp-location-box-close"><span>x</span></div>
                <input 
                    type="hidden" 
                    class="id" value="<?php echo $key?>">
            </div>
        </div>
        <div class="dsp-location-box-con">
            <div class="dsp-location-box-con-inputs">
                <div class="dsp-location-box-con-inputs-input dsp-location-box-con-inputs-input-enabled">
                    <div class="dsp-location-box-default">
                        <input 
                        type="checkbox" 
                        class="enable" 
                        id="enable_<?php echo $key?>" 
                        <?php if ($location['enable']=="true") { ?> checked <?php } ?>
                        >
                        <label for="enable_<?php echo $key?>"><?php echo __('Enabled','datalogics_shipping')?></label>   
                    </div>
                    <div class="dsp-location-box-default">
                        <input 
                            type="checkbox" 
                            class="default" 
                            id="default_<?php echo $key?>" 
                            <?php if ($location['default']=="true") { ?> checked <?php } ?>>
                        <label for="default_<?php echo $key?>"><?php echo __('Set Default','datalogics_shipping')?></label>                                                
                    </div>                                              
                </div>                                                                                       
                <div class="dsp-location-box-con-inputs-input">
                    <label for="name_<?php echo $key?>"><?php echo __('Location name','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="name_<?php echo $key?>" 
                        class="name" 
                        value="<?php echo $location['name']?>">
                </div> 
                <div class="dsp-location-box-con-inputs-input">
                    <label for="label_<?php echo $key?>"><?php echo __('Company label name','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="label_<?php echo $key?>" 
                        class="label" 
                        value="<?php echo $location['label']?>">
                </div>  
                <div class="dsp-location-box-con-inputs-input">
                    <label for="city_<?php echo $key?>"><?php echo __('City','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="city_<?php echo $key?>" 
                        class="city" 
                        value="<?php echo $location['city']?>">
                </div> 
                <div class="dsp-location-box-con-inputs-input">
                    <label for="street_<?php echo $key?>"><?php echo __('Street','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="street_<?php echo $key?>" 
                        class="street" 
                        value="<?php echo $location['street']?>">
                </div> 
                <div class="dsp-location-box-con-inputs-input">
                    <label for="house_<?php echo $key?>"><?php echo __('House','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="house_<?php echo $key?>" 
                        class="house" 
                        value="<?php echo $location['house']?>">
                </div> 
                <div class="dsp-location-box-con-inputs-input">
                    <label for="phone_<?php echo $key?>"><?php echo __('Phone','datalogics_shipping')?></label>
                    <input 
                        type="text"
                        id="phone_<?php echo $key?>" 
                        class="phone" 
                        value="<?php echo $location['phone']?>">
                </div>                                                  
            </div>
        </div>
        <!-- <div class="dsp-location-box-default">
            <input 
                type="checkbox" 
                class="default" 
                id="default_<?php echo $key?>" 
                <?php if ($location['default']=="true") { ?> checked <?php } ?>>
            <label for="default_<?php echo $key?>"><?php echo __('Set Default','datalogics_shipping')?></label>                                                
        </div> -->
    </div>
    <?php

    return ob_get_clean();

}

function getCompanyHtmlBox($company,$exist,$hidden='') {

    $platform_id = $company['platform_id'];

    ob_start();

    $image = plugins_url('/images/logos/'.$company['logo'], __FILE__);
    if (!file_exists($image)) {
        $image = plugins_url('/images/truckstatic.svg', __FILE__);
    }
    ?>
    <div class="dsp-companies-box dsp-companies-box<?php echo $platform_id?><?php if ($hidden!='') { ?> dsp-companies-box-hidden<?php } ?>">
        <div class="dsp-companies-box-top">            
            <div class="">                
                <input 
                    type="hidden" 
                    class="shipping_push_supplier" 
                    value="<?php echo $platform_id?>">
                <div class="dsp-companies-box-name"><?php echo $company['name']?></div>
            </div>
            <span class="dsp-companies-box-close"><span>x</span></span>
        </div>        
        
        <div class="dsp-companies-box-con">
            <!-- <div class="dsp-companies-box-con-image"><img src="<?php echo $image?>"></div> -->
            <div class="dsp-companies-box-con-inputs">
                    <div class="dsp-companies-box-con-inputs-input dsp-companies-box-con-inputs-input-enabled">
                        <div class="dsp-companies-box-default">
                            <input 
                                type="checkbox" 
                                class="shipping_push_supplier_enable" 
                                id="enable_<?php echo $platform_id?>" 
                                <?php if (isset($exist['shipping_push_supplier_enable']) && $exist['shipping_push_supplier_enable']=="true") { ?> checked <?php } ?>>
                            <label for="enable_<?php echo $platform_id?>"><?php echo __('Enabled','datalogics_shipping')?></label>                                                
                        </div>
                        <div class="dsp-companies-box-default">
                            <input 
                                type="checkbox" 
                                class="shipping_push_supplier_default" 
                                id="default_<?php echo $platform_id?>" 
                                <?php if ($exist['shipping_push_supplier_default']=="true") { ?> checked <?php } ?>>
                            <label for="default_<?php echo $platform_id?>"><?php echo __('Set Default','datalogics_shipping')?></label>                                                
                        </div>
                    </div>
                <?php 
                if (isset($company['postil']) && $company['postil']==1) {
                    ?>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="contract_<?php echo $platform_id?>"><?php echo __('Courier Contract ID','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="contract_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_contract" 
                            value="<?php echo $exist['shipping_push_supplier_contract']?>">                                                    
                    </div> 
                    <?php

                }else if (isset($company['zigzag']) && $company['zigzag']==1) { 
                ?>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="username1_<?php echo $platform_id?>"><?php echo __('Username 1','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="username1_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_username1" 
                            value="<?php echo $exist['shipping_push_supplier_username1']?>">                                                    
                    </div> 
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="username2_<?php echo $platform_id?>"><?php echo __('Username 2','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="username2_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_username2" 
                            value="<?php echo $exist['shipping_push_supplier_username2']?>">     
                    </div>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="username3_<?php echo $platform_id?>"><?php echo __('Username 3','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="username1_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_username3" 
                            value="<?php echo $exist['shipping_push_supplier_username3']?>">     
                    </div>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="password_<?php echo $platform_id?>"><?php echo __('Password','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="password_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_password" 
                            value="<?php echo $exist['shipping_push_supplier_password']?>">     
                    </div>                                           
                <?php 
                } else if (isset($company['bar']) && $company['bar']==1) { 
                    ?>
                        <div class="dsp-companies-box-con-inputs-input">
                            <label for="auth_username_<?php echo $platform_id?>"><?php echo __('Auth Username','datalogics_shipping')?></label>
                            <input 
                                type="text"
                                id="auth_username_<?php echo $platform_id?>" 
                                class="shipping_push_supplier_auth_username" 
                                value="<?php echo $exist['shipping_push_supplier_auth_username']?>">                                                    
                        </div> 
                        <div class="dsp-companies-box-con-inputs-input">
                            <label for="auth_password_<?php echo $platform_id?>"><?php echo __('Auth Password','datalogics_shipping')?></label>
                            <input 
                                type="text"
                                id="auth_password_<?php echo $platform_id?>" 
                                class="shipping_push_supplier_auth_password" 
                                value="<?php echo $exist['shipping_push_supplier_auth_password']?>">     
                        </div>
                        <div class="dsp-companies-box-con-inputs-input">
                            <label for="username_<?php echo $platform_id?>"><?php echo __('Username','datalogics_shipping')?></label>
                            <input 
                                type="text"
                                id="username_<?php echo $platform_id?>" 
                                class="shipping_push_supplier_username" 
                                value="<?php echo $exist['shipping_push_supplier_username']?>">     
                        </div>
                        <div class="dsp-companies-box-con-inputs-input">
                            <label for="password_<?php echo $platform_id?>"><?php echo __('Password','datalogics_shipping')?></label>
                            <input 
                                type="text"
                                id="password_<?php echo $platform_id?>" 
                                class="shipping_push_supplier_password" 
                                value="<?php echo $exist['shipping_push_supplier_password']?>">     
                        </div>  
                        <div class="dsp-companies-box-con-inputs-input">
                            <label for="code_<?php echo $platform_id?>"><?php echo __('Customer Code','datalogics_shipping')?></label>
                            <input 
                                type="text"
                                id="code_<?php echo $platform_id?>" 
                                class="shipping_push_supplier_code" 
                                value="<?php echo $exist['shipping_push_supplier_code']?>">     
                        </div>                                           
                    <?php 
                    
                } else {
                ?>                                                
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="code_<?php echo $platform_id?>"><?php echo __('Customer ID Door2Door','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="code_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_code" 
                            value="<?php echo $exist['shipping_push_supplier_code']?>">
                    </div>
                    <?php if ($company['pickup']==1) {  ?>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="code_pickup_<?php echo $platform_id?>"><?php echo __('Customer ID Pickup','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="code_pickup_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_code_pickup" 
                            value="<?php echo $exist['shipping_push_supplier_code_pickup']?>">
                    </div>
                    <?php } ?>
                    <?php if ($company['token']==1) {  ?>
                    <div class="dsp-companies-box-con-inputs-input">
                        <label for="token_<?php echo $platform_id?>"><?php echo __('Token','datalogics_shipping')?></label>
                        <input 
                            type="text"
                            id="token_<?php echo $platform_id?>" 
                            class="shipping_push_supplier_token" 
                            value="<?php echo $exist['shipping_push_supplier_token']?>">
                    </div>
                    <?php } ?>
                <?php } ?>
            </div>
        </div>        
    </div>
    <?php

    return ob_get_clean();

}


?>

<div id="datalogics_loader_con" class="hide">
    <div class="dsb-spinner"><div></div><div></div><div></div><div></div></div>
    <div id="datalogics_loader_text"><?php echo __('Loading settings','datalogics_shipping')?></div>
</div>

<div id="pluginwrap" class="settings-page">
    
    <?php
    $shipping_push_products_in_comments = get_option('shipping_push_products_in_comments','') ? 'checked' : '';

    $test = get_option('shipping_push_products_in_comments','');

    

    $datalogics_google_key              = get_option('datalogics_google_key','');
    $shipping_push_notes_in_comments    = get_option('shipping_push_notes_in_comments','') ? 'checked' : '';
    $datalogics_cities_list             = get_option('datalogics_cities_list','') ? 'checked' : '';
    $datalogics_skip_jquery             = get_option('datalogics_skip_jquery','') ? 'checked' : '';
    $datalogics_cities_auto             = get_option('datalogics_cities_auto','') ? 'checked' : '';
    $datalogics_cities_auto_validation  = get_option('datalogics_cities_auto_validation','') ? 'checked' : '';
    $datalogics_custom_label            = get_option('datalogics_custom_label','') ? 'checked' : '';   
    $datalogics_ncode_auto              = get_option('datalogics_ncode_auto','') ? 'checked' : '';
    $datalogics_shipping_options_enabled= get_option('datalogics_shipping_options_enabled','') ? 'checked' : '';
    $datalogics_myaccount_tracking      = get_option('datalogics_myaccount_tracking','') ? 'checked' : '';
    $datalogics_myaccount_tracking_email= get_option('datalogics_myaccount_tracking_email','') ? 'checked' : '';
    $datalogics_myaccount_tracking_email_link = get_option('datalogics_myaccount_tracking_email_link','');
    $order_statuses_limit               = get_option('order_statuses_limit','');
    $datalogics_view_option             = get_option('datalogics_view_option','');
    
    $datalogics_print_logo = get_option('datalogics_print_logo','');
    $datalogics_print_pattern = get_option('datalogics_print_pattern','');

    


    if (isset($_GET['success'])) {

        $success_msg = __('Successfully saved!', 'datalogics_shipping');
        datalogics_update_locations();

    } else {

        $success_msg = '';


    }

    $order_statuses = wc_get_order_statuses();
    $current_order_status = get_option('shipping_order_status', '');
    $datalogics_location_select = get_option('datalogics_location_select', 'map');

    $shipping_options = WC()->shipping->load_shipping_methods();

    $current_shipping_options = get_option('datalogics_shipping_options', '');
    if ($current_shipping_options == '') {
        $current_shipping_options = [];
    } else {
        $current_shipping_options = json_decode($current_shipping_options);
        if (!is_array($current_shipping_options)) {
            $current_shipping_options = [];
        }
    }


    ?>
    <div class="dsp-box">
        <div class="dsp-box-menu">
            <a href="?page=datalogics-settings" data-con="dsp-license" 
                class="<?php if ($datalogics_url_section==''){ ?> dsp-box-menu-selected<?php } ?>">
                <?php echo __('License', 'datalogics_shipping'); ?>
            </a>
            <a href="?page=datalogics-settings&section=companies"  data-con="dsp-companies" 
                class="<?php if ($datalogics_url_section=='companies'){ ?> dsp-box-menu-selected<?php } ?>">
                <?php echo __('Shipping Companies', 'datalogics_shipping'); ?>
            </a>
            <a href="?page=datalogics-settings&section=locations" data-con="dsp-locations" 
                class="<?php if ($datalogics_url_section=='locations'){ ?> dsp-box-menu-selected<?php } ?>">
                <?php echo __('Locations', 'datalogics_shipping'); ?>
            </a>
            <a href="?page=datalogics-settings&section=settings" data-con="dsp-settings" 
                class="<?php if ($datalogics_url_section=='settings'){ ?> dsp-box-menu-selected<?php } ?>">
                <?php echo __('Global Settings', 'datalogics_shipping'); ?>
            </a>
        </div>
        <div class="dsp-box-content">        
            <form id="datalogics_settings_form" 
                    name="datalogics_settings_form" 
                    action="<?= admin_url('admin-post.php') ?>"
                    method="post">

                    

                <div class="dsp-license<?php if ($datalogics_url_section!=''){ ?> dsp-hide<?php } ?>">

                    <h1>
                        <?php if (DATALOGICS_COMPANY=='POSTIL') { ?>
                            <?php echo __('Welcome to Israel Post Domestic Shipping', 'datalogics_shipping'); ?>
                        <?php } else { ?>
                            <?php echo __('Welcome to Datalogics Shipping', 'datalogics_shipping'); ?>
                        <?php }?>
                    </h1>
                    
                    <p>
                        <?php echo __('In case you already have an License key please fill the license key in the following box.', 'datalogics_shipping'); ?>
                    </p>
                    <p>
                        <?php echo __('In case you dont have an License key Please register in the registration box below', 'datalogics_shipping'); ?>
                    </p>
                    <?php if (DATALOGICS_COMPANY!='POSTIL') { ?>
                    <p>
                        <?php echo __('For support and information please contact us via:', 'datalogics_shipping'); ?>
                        <a href="https://docs.datalogics.co.il/">https://docs.datalogics.co.il</a>
                    </p>
                    <?php } ?>

                    <!-- <p>
                        <a target="_blank" href="https://docs.datalogics.co.il/%D7%94%D7%AA%D7%A7%D7%A0%D7%AA-%D7%AA%D7%95%D7%A1%D7%A3-%D7%A9%D7%9C%D7%99%D7%97%D7%95%D7%99%D7%95%D7%AA-%D7%9C-wordpress-woocommerce">
                            <?php echo __('Installation Tutorial', 'datalogics_shipping'); ?>
                        </a>
                    </p> -->

                    <div class="dsp-key">
                        <h2>                        
                        <?php if (DATALOGICS_COMPANY!='POSTIL') { ?>
                            <?php echo __('Setup your Datalogics Account', 'datalogics_shipping'); ?>
                        <?php } else { ?>
                            <?php echo __('Setup your Israel Post Domestic Account', 'datalogics_shipping'); ?>
                        <?php } ?>
                        </h2>
                        <label for="datalogics_token">
                            <div><?= __('Datalogics License', 'datalogics_shipping') ?></div>
                        </label>
                        <?php 
                        $token = get_option('datalogics_token', '');
                        ?>                   
                        <input type="text" id="datalogics_token" name="datalogics_token" value="<?= $token; ?>">
                        <button type="button" id="datalogics_check_key" class="dsp-button"><?= __('Check Key', 'datalogics_shipping') ?></button>
                        <span class="dsp-validation">
                            <?php /*<span class="check"><?= __('Validating your license', 'datalogics_shipping') ?></span>*/?>
                            <span class="valid dsp-hide"><?= __('They License Key is Valid', 'datalogics_shipping') ?></span>
                            <span class="invalid dsp-hide"><?= __('They License Key is invalid', 'datalogics_shipping') ?></span>
                        </span>   
                        
                        <div class="dsp-payment-link dsp-hide">
                            <div><?= __('14 days free trial is over, you use the plugin please purchase the yearly license in the link ', 'datalogics_shipping') ?></div>
                            <div><a href="" target="_blank"></a></div>
                        </div>
                    </div>

                    <div class="dsp-products dsp-hide">
                            <div class="dsp-products-title"><?= __('More of our Products', 'datalogics_shipping') ?></div>
                            <div class="dsp-products-subtitle"><?= __('All our products are compatible with Wordpress,Shopify,Wix and many more platforms. for more info contact us:', 'datalogics_shipping') ?><a href="mailto:tal@datalogics.co.il">tal@datalogics.co.il</a></div>
                            <div class="dsp-products-list">
                                <!-- <div class="dsp-prod">
                                    <div class="dsp-prod-image"><img src=""></div>
                                    <div class="dsp-prod-name"><img src=""></div>
                                </div> -->
                            </div>
                    </div>

                    <div class="dsp-reg dsp-hide">
                        <h2>
                            <?php echo __('Register your Datalogics account', 'datalogics_shipping'); ?>
                        </h2>
                        <div class="dsp-reg-table">
                            <div class="dsp-reg-box">
                                <label for="datalogics_firstname">
                                    <div><?= __('First Name', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_firstname" name="datalogics_firstname" value="<?php echo get_option('datalogics_firstname','')?>">                    
                            </div> 
                            <div class="dsp-reg-box">
                                <label for="datalogics_lastname">
                                    <div><?= __('Last Name', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_lastname" name="datalogics_lastname" value="<?php echo get_option('datalogics_lastname','')?>">                    
                            </div> 
                            <div class="dsp-reg-box">
                                <label for="datalogics_company">
                                    <div><?= __('Company Name', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_company" name="datalogics_company" value="<?php echo get_option('datalogics_company','')?>">                    
                            </div> 
                            <div class="dsp-reg-box">
                                <label for="datalogics_vat_number">
                                    <div><?= __('VAT Number', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_vat_number" name="datalogics_vat_number" value="<?php echo get_option('datalogics_vat_number','')?>">                    
                            </div> 
                            <div class="dsp-reg-box">
                                <label for="datalogics_email">
                                    <div><?= __('Email', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_email" name="datalogics_email" value="<?php echo get_option('datalogics_email','')?>">                    
                            </div> 
                            <div class="dsp-reg-box">
                                <label for="datalogics_phone">
                                    <div><?= __('Phone', 'datalogics_shipping') ?></div>
                                </label>                                     
                                <input type="text" id="datalogics_phone" name="datalogics_phone" value="<?php echo get_option('datalogics_phone','')?>">                    
                            </div> 
                        </div>
                        <button type="button" id="datalogics_register" class="dsp-button"><?= __('Register', 'datalogics_shipping') ?></button>            
                    </div>
                    <?php if (DATALOGICS_COMPANY!='POSTIL') { ?>
                    <div class="dsp-support">                        
                        <?php echo __('Download our latest versions from that link:', 'datalogics_shipping'); ?>
                        <a href="https://docs.datalogics.co.il/downloads/datalogics.zip" target="_blank">datalogics.zip</a>                    
                    </div>
                    <?php } ?>
                </div>

                <div class="dsp-companies<?php if ($datalogics_url_section!='companies'){ ?> dsp-hide<?php } ?>">
                    <h1>
                        <?php echo __('Set your shipping companies', 'datalogics_shipping'); ?>
                    </h1>
                    <?php
                    $existing_companies = get_option('datalogics_shipping_method', '');

                    $existing_companies = json_decode($existing_companies,true); 

                    if (DATALOGICS_COMPANY=='POSTIL') {

                        $post_il_company_passed = false;                        
                        foreach($existing_companies as $exist_company) {
                            if ($exist_company['shipping_push_supplier']==62) {
                                $post_il_company_passed = true;
                            }
                        }

                        if ($existing_companies=='' || empty($existing_companies) || $post_il_company_passed == false) { 

                            $existing_companies[] = ['shipping_push_supplier'=>62];  

                        }
                    }
                     
                    
                    $companies = get_option('datalogics_shipping_companies');
                    if ($companies!='') {
                        
                        $companies = json_decode($companies,true);  
                    } else {
                        $companies = [];                        

                    }
                    if (DATALOGICS_COMPANY!='POSTIL') {
                    ?>
                    <div class="companies-container-list">
                        <select>
                            <option value=""><?php echo __('Please choose company', 'datalogics_shipping') ?></option>
                            <?php
                            foreach($companies as $platform_id=>$company) {
                                ?>
                                <option value="<?php echo $platform_id?>"><?php echo $company['name']?></option>
                                <?php
                            }
                            ?>
                        </select>
                        <button type="button" id="datalogics_add_companies" class="dsp-button"><?= __('Add', 'datalogics_shipping') ?></button>
                    </div>
                    <?php 
                    } 
                    ?>
                    <div class="companies-container">
                        <?php
                        foreach($companies as $platform_id=>$company) {

                            $company['platform_id'] = $platform_id;

                            $exist = [];

                            foreach($existing_companies as $exist_company) {

                                if ($exist_company['shipping_push_supplier']==$platform_id) {

                                    $exist = $exist_company;

                                }

                            }

                            $hidden = '';
                            if (empty($exist)) {
                                $hidden = 1;
                            }

                            if (DATALOGICS_COMPANY=='POSTIL') {
                                if (!empty($exist)) {
                                    if ($exist['shipping_push_supplier']!=62) {
                                        $hidden = 1;
                                    }
                                }
                            }



                            echo getCompanyHtmlBox($company,$exist,$hidden);
                        }

                        if (empty($existing_companies)) {

                            ?>
                            <div class="dsp-companies-con-empty"><?php echo __('Please add companies', 'datalogics_shipping') ?></div>    
                            <?php
                        }
                        ?>                        
                    </div>
                    <div class="dsp-companies-box-button">
                        <button type="button" id="datalogics_save_companies" class="dsp-button"><?= __('Save', 'datalogics_shipping') ?></button>    
                    </div>

                </div>

                
                <div class="dsp-locations<?php if ($datalogics_url_section!='locations'){ ?> dsp-hide<?php } ?>">  
                    <h1>

                        <?php echo __('Setup your locations', 'datalogics_shipping'); ?>
                    </h1>                  

                    <div class="dsp-locations-con">                        
                        <?php    
                        $location_counter = 0;                    
                        $locations = get_option('datalogics_update_inventory_locations',''); 
                        if ($locations!='') {
                            
                            $locations = json_decode($locations,true);   
                            foreach($locations as $key=>$location) {
        
                                echo getLocationHtmlBox($location,$key);

                                $location_counter++;

                            }
                        }  else {

                            ?>
                            <div class="dsp-locations-con-empty"><?php echo __('Please add location', 'datalogics_shipping') ?></div>    
                            <?php

                        }                      
                        ?> 
                    </div>
                    <?php echo getLocationHtmlBox([],$location_counter,$hidden=1); ?>
                    <div class="dsp-location-box-button">
                        <button type="button" id="datalogics_location_save" class="dsp-button"><?= __('Save', 'datalogics_shipping') ?></button>    
                        <button type="button" id="datalogics_location_add" class="dsp-button"><?= __('Add', 'datalogics_shipping') ?></button>    
                    </div>                    

                </div>

                <div class="dsp-settings<?php if ($datalogics_url_section!='settings'){ ?> dsp-hide<?php } ?>">
                    <h1>
                        <?php echo __('Plugin settings', 'datalogics_shipping'); ?>
                    </h1>
                    <table>           
                        
                        <tr>
                            <td><input type="checkbox" id="shipping_push_notes_in_comments" name="shipping_push_notes_in_comments"
                                    value="1" <?= $shipping_push_notes_in_comments; ?>></td>
                            <td>
                                <label for="shipping_push_notes_in_comments"><?= __('Show notes in shipping comments', 'datalogics_shipping') ?></label>
                            </td>
                        </tr>
                        <tr>
                            <td><input type="checkbox" id="shipping_push_products_in_comments"
                                    name="shipping_push_products_in_comments"
                                    value="1" <?= $shipping_push_products_in_comments; ?>></td>
                            <td>
                                <label for="shipping_push_products_in_comments"><?= __('Products in comments', 'datalogics_shipping') ?></label>
                            </td>
                        </tr>
                        <?php 
                        /*
                        <tr>
                            <td><input type="checkbox" id="datalogics_cities_list" name="datalogics_cities_list"
                                    value="1" <?= $datalogics_cities_list; ?>></td>
                            <td>
                                <label for="datalogics_cities_list"><?= __('Replace city input in selectbox', 'datalogics_shipping') ?></label>
                            </td>
                        </tr>
                        */
                        ?>

                        <tr>
                            <td><input type="checkbox" id="datalogics_cities_auto" name="datalogics_cities_auto"
                                    value="1" <?= $datalogics_cities_auto; ?>></td>
                            <td>
                                <label for="datalogics_cities_auto"><?= __('Replace city input in Autocomplete', 'datalogics_shipping') ?></label>
                            </td>
                        </tr>                        
                        <tr>
                            <td><input type="checkbox" id="datalogics_cities_auto_validation" name="datalogics_cities_auto_validation"
                                    value="1" <?= $datalogics_cities_auto_validation; ?>></td>
                            <td>
                                <label for="datalogics_cities_auto_validation"><?= __('Force Address Autocomplete Validation', 'datalogics_shipping') ?></label>
                            </td>
                        </tr>
                                   <tr>
                            <td valign="top">
                                <input type="checkbox" 
                                        id="datalogics_skip_jquery" 
                                        name="datalogics_skip_jquery"
                                        value="1" <?= $datalogics_skip_jquery; ?>>
                            </td>
                            <td>
                                <label for="datalogics_skip_jquery">
                                    <?= __('Skip jQuery', 'datalogics_shipping') ?>
                                </label>
                                <div class="comment">*<?= __('Activate this option in case you have issues in the checkout', 'datalogics_shipping') ?></div>
                            </td>
                        </tr>

                        <tr>
                            <td colspan="2">
                                <label for="order_statuses"><?= __('Select a status for automatically send shipping:', 'datalogics_shipping'); ?></label>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <select id="order_statuses" name="order_statuses" class="dsp-selectbox">
                                    <option value=""><?= __('Select status', 'datalogics_shipping'); ?></option>
                                    <?php
                                    foreach ($order_statuses as $key => $status) {
                                        ?>
                                        <option value="<?= $key; ?>"<?= ($key == $current_order_status) ? 'selected' : ''; ?>><?= $status; ?></option>
                                        <?php
                                    }
                                    ?>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <label for="order_statuses_limit"><?= __('Allow sending automatic orders that are greater than order number', 'datalogics_shipping'); ?></label>
                                <input type="text" id="order_statuses_limit" name="order_statuses_limit"
                                    value="<?php echo $order_statuses_limit; ?>">
                            </td>
                        </tr>
                    </table>


                    <h3><?php echo __('Filter by shipping method', 'datalogics_shipping'); ?></h3>
                    <table>
                        <tr>
                            <td><input type="checkbox" id="datalogics_shipping_options_enabled" name="datalogics_shipping_options_enabled"
                                    value="1" <?= $datalogics_shipping_options_enabled; ?>></td>
                            <td><label for="datalogics_shipping_options_enabled"><?= __('Select shipping options', 'datalogics_shipping'); ?></label></td>
                        </tr>
                    </table>
                    <?php 
                    if (!empty($shipping_options)) {
                    ?>
                    <table>
                        <tr>
                            <td colspan="2">
                            <span style="color: red"><?= __('* Only select shipping options will be available for creating deliveries', 'datalogics_shipping'); ?></span>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">

                        <select name="datalogics_shipping_options[]" id="datalogics_shipping_options" multiple
                                style="height:150px;" <?php if ($datalogics_shipping_options_enabled=='') { ?> disabled<?php } ?>>
                            <?php
                            foreach ($shipping_options as $key => $shipping_option) 
                            {
                                ?>
                                <option value="<?= $shipping_option->id; ?>"<?php if (in_array($shipping_option->id, $current_shipping_options)) { echo 'selected'; } ?>><?php echo $shipping_option->method_title; ?></option>
                                <?php
                            }
                            ?>
                        </select>
                            </td>
                        </tr>
                    </table>
                    <?php 
                    }
                    ?> 

                    <h3><?php echo __('Delivery Tracking', 'datalogics_shipping'); ?></h3>
                    <table>

                        
                        <tr>
                            <td><input type="checkbox" id="datalogics_myaccount_tracking" name="datalogics_myaccount_tracking"
                                    value="1" <?= $datalogics_myaccount_tracking; ?>></td>
                            <td>
                                <label for="datalogics_myaccount_tracking">
                                    <?= __('Enable shipment tracking inside my account', 'datalogics_shipping') ?>
                                    <span class="comment"><?= __('(Pro version)', 'datalogics_shipping') ?></span>
                                </label>
                            </td>
                        </tr>

                        <tr>
                            <td><input type="checkbox" id="datalogics_myaccount_tracking_email" name="datalogics_myaccount_tracking_email"
                                    value="1" <?= $datalogics_myaccount_tracking_email; ?>></td>
                            <td>
                                <label for="datalogics_myaccount_tracking_email">
                                    <?= __('Enable Email on shipment tracking update', 'datalogics_shipping') ?>
                                    <span class="comment"><?= __('(Pro version)', 'datalogics_shipping') ?></span>
                                </label>
                            </td>
                        </tr>


                        <tr>
                            <td></td>
                            <td>
                                <label for="datalogics_myaccount_tracking_email_link"><?= __('Custom Tracking link', 'datalogics_shipping') ?></label>
                                <input type="text" id="datalogics_myaccount_tracking_email_link" name="datalogics_myaccount_tracking_email_link"
                                    value="<?php echo $datalogics_myaccount_tracking_email_link; ?>"><br>
                                <span class="comment"><?= __('Leave empty if no custom link', 'datalogics_shipping') ?></span>       
                            </td>
                        </tr>

                    </table>

                    <h3><?php echo __('Pudo Settings', 'datalogics_shipping'); ?></h3>
                    
                    <table> 
                        <tbody>
                            <tr>
                                <td colspan="2">
                                    <label for="datalogics_view_option"><?= __('Select Maps View Option', 'datalogics_shipping') ?></label>
                                    <select id="datalogics_view_option" class="dsp-selectbox">
                                        <option value="2" <?php if ($datalogics_view_option==2) { echo " selected "; }?>><?= __('List', 'datalogics_shipping') ?></option>
                                        <option value="0" <?php if ($datalogics_view_option==0) { echo " selected "; }?>><?= __('Map', 'datalogics_shipping') ?> (<?= __('Google Maps Api is Mandatory', 'datalogics_shipping') ?>)</option>
                                    </select>
                                </td>
                            </tr>           
                            <tr>
                                <td colspan="2">
                                    <label for="datalogics_google_key"><?= __('Google Places+Geocoding Api Key ( in case youre using Maps )', 'datalogics_shipping') ?></label>
                                    <input type="text" id="datalogics_google_key" name="datalogics_google_key" value="<?php echo $datalogics_google_key; ?>">
                                    <div class="comment">
                                        <a href="https://www.youtube.com/watch?v=OGTG1l7yin4" target="_blank"><?= __('How to get Google Key', 'datalogics_shipping') ?></a>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><input type="checkbox" id="datalogics_ncode_auto" name="datalogics_ncode_auto" <?= $datalogics_ncode_auto; ?>></td>
                                <td>
                                    <label for="datalogics_ncode_auto"><?= __('Replace Pickup input in Autocomplete', 'datalogics_shipping') ?></label>
                                </td>
                            </tr>
                        </tbody>
                    </table>


                    <h3><?php echo __('Labels printing', 'datalogics_shipping'); ?></h3>
                    <table>
                        <tbody>
                            <tr>
                                <td><input type="checkbox" id="datalogics_custom_label" name="datalogics_custom_label" <?php echo ($datalogics_custom_label) ? 'checked' : ''?>>
                                </td>
                                <td>
                                    <label for="datalogics_custom_label"><?= __('Enable Custom printing label', 'datalogics_shipping') ?></label>
                                </td>                            
                            </tr>
                            <?php if (DATALOGICS_COMPANY!='POSTIL') { ?>
                            <tr>
                                <td colspan="2">
                                    <label for="datalogics_print_pattern"><?= __('Choose print pattern', 'datalogics_shipping') ?></label>
                                    <select id="datalogics_print_pattern" class="dsp-selectbox">
                                        <option value="1" <?php echo ($datalogics_print_pattern==1) ? 'selected'  : ''?>><?= __('Pattern 1', 'datalogics_shipping') ?></option>
                                        <option value="2" <?php echo ($datalogics_print_pattern==2) ? 'selected'  : ''?>><?= __('Pattern 2', 'datalogics_shipping') ?></option>
                                    </select>
                                </td>
                            </tr>
                            <?php } ?>
                            <tr>
                                <td></td>
                                <td>
                                    <input type="file" id="datalogics_print_logo_image">  
                                    <?php wp_nonce_field('datalogics_upload_image_nonce', 'datalogics_upload_image_nonce'); ?>                              
                                   
                                    <div class="current-image-container">
                                        <?php if ($datalogics_print_logo!='') { ?>
                                        <img src="<?php echo $datalogics_print_logo?>" style="width:100px">
                                        <?php } ?>
                                    </div>
                                    <button id="datalogics_upload_image_delete" type="button"><?= __('Delete image', 'datalogics_shipping') ?></button>
                                    <input type="hidden" name="image" id="datalogics_upload_image_value" value="<?php $datalogics_print_logo?>">
                                </td>
                            </tr>
                        </tbody>
                    </table>





                    <h3><?php echo __('Checkout Fields Mapping', 'datalogics_shipping'); ?></h3>
                    <div class="dsp-settings-mapping">
                        <div class="dsp-settings-mapping-col">
                            <h3><?php echo __('Billing Mapping', 'datalogics_shipping'); ?></h3>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_street"><?php echo __('Street Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_street" 
                                    class="map_billing_street" 
                                    value="<?php 
                                            $address1 = get_option('datalogics_billing_map_street',''); 
                                            echo ($address1!='') ? $address1 : 'address_1';?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_house"><?php echo __('House number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_house" 
                                    class="map_billing_house" 
                                    value="<?php 
                                            $address2 = get_option('datalogics_billing_map_house',''); 
                                            echo ($address2!='') ? $address2 : 'address_2';?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_apartment"><?php echo __('Apartment number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_apartment" 
                                    class="map_billing_apartment" 
                                    value="<?php echo get_option('datalogics_billing_map_apartment','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_entrance"><?php echo __('Entrence number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_entrance" 
                                    class="map_billing_entrance" 
                                    value="<?php echo get_option('datalogics_billing_map_entrance','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_floor"><?php echo __('Floor number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_floor" 
                                    class="map_billing_floor" 
                                    value="<?php echo get_option('datalogics_billing_map_floor','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_billing_door"><?php echo __('Door number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_billing_door" 
                                    class="map_billing_door" 
                                    value="<?php echo get_option('datalogics_billing_map_door','')?>">                                                    
                            </div>
                        </div>
                        <div class="dsp-settings-mapping-col">
                            <h3><?php echo __('Shipping Mapping', 'datalogics_shipping'); ?></h3>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_shipping_street"><?php echo __('Street Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_street" 
                                    class="map_shipping_street" 
                                    value="<?php 
                                            $address2 = get_option('datalogics_shipping_map_street',''); 
                                            echo ($address1!='') ? $address1 : 'address_1';?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_house"><?php echo __('House number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_house" 
                                    class="map_shipping_house" 
                                    value="<?php 
                                            $address2 = get_option('datalogics_shipping_map_house',''); 
                                            echo ($address2!='') ? $address2 : 'address_2';?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_shipping_apartment"><?php echo __('Apartment number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_apartment" 
                                    class="map_shipping_apartment" 
                                    value="<?php echo get_option('datalogics_shipping_map_apartment','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_shipping_entrance"><?php echo __('Entrence number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_entrance" 
                                    class="map_shipping_entrance" 
                                    value="<?php echo get_option('datalogics_shipping_map_entrance','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_shipping_floor"><?php echo __('Floor number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_floor" 
                                    class="map_shipping_floor" 
                                    value="<?php echo get_option('datalogics_shipping_map_floor','')?>">                                                    
                            </div>
                            <div class="dsp-companies-box-con-inputs-input">
                                <label for="map_shipping_door"><?php echo __('Door number Field','datalogics_shipping')?></label>
                                <input 
                                    type="text"
                                    id="map_shipping_door" 
                                    class="map_shipping_door" 
                                    value="<?php echo get_option('datalogics_shipping_map_door','')?>">                                                    
                            </div>
                        </div>
                    </div>
                    <div class="dsp-settings-mapping-box-button">
                        <button type="button" id="datalogics_settings_save" class="dsp-button"><?= __('Save', 'datalogics_shipping') ?></button>    
                    </div>
                    
                </div>               

            </form>
        </div>
    </div>
</div>