<?php

/*
 * Check if WooCommerce is active
 */
if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {

    function enque_map()
    {

        if ( is_checkout() ) {


            $datalogics_view_option = get_option('datalogics_view_option','');

            $datalogics_google_key = get_option('datalogics_google_key', '');

            if ($datalogics_google_key!='') {            
            
                wp_enqueue_script('datalogics-shipping2', 'https://maps.googleapis.com/maps/api/js?v=3.exp&amp;sensor=false&amp;key='.$datalogics_google_key.'&amp;libraries=places&amp;callback=Function.prototype');
            
            }
            //wp_enqueue_script('datalogics-shipping2', 'https://maps.googleapis.com/maps/api/js?v=3.exp&amp;sensor=false&amp;key=AIzaSyBF8t7y1o9ZV7O2D0kdWSm3pe9Bua_D0Fg&amp;libraries=places');
            //wp_enqueue_script( 'datalogics-shipping-jquery','https://ajax.googleapis.com/ajax/libs/jquery/3.4.0/jquery.min.js');

            // $datalogics_skip_jquery = get_option('datalogics_skip_jquery', '');
            // if ($datalogics_skip_jquery == '') {

            //     wp_enqueue_script('datalogics-shipping-jquery', plugins_url('/js/jquery-3.6.0.min.js', __FILE__));
                

            // }

            if ($datalogics_view_option < 2) {

                wp_enqueue_script('leaflet', add_query_arg( DATALOGICS_ARGS,plugins_url('/js/leaflet.js', __FILE__)));
                wp_enqueue_script('leaflet-markercluster', add_query_arg( DATALOGICS_ARGS,plugins_url('/js/leaflet.markercluster-src.js', __FILE__)));
                wp_register_style('leaflet', 'https://unpkg.com/leaflet@1.7.1/dist/leaflet.css');
                wp_register_style('leaflet-markercluster-css', add_query_arg( DATALOGICS_ARGS,plugins_url('/css/MarkerCluster.css', __FILE__)));
                wp_register_style('leaflet-markercluster-css-def', add_query_arg( DATALOGICS_ARGS,plugins_url('/css/MarkerCluster.Default.css', __FILE__)));
                wp_enqueue_style('leaflet');
                wp_enqueue_style('leaflet-markercluster-css');
                wp_enqueue_style('leaflet-markercluster-css-def');                

            }

            wp_enqueue_style('jquery-ui-css', plugin_dir_url(__FILE__) . 'css/jquery-ui.css');
            wp_enqueue_script('jquery');
            wp_enqueue_script('jquery-ui-js', plugin_dir_url(__FILE__) . 'js/jquery-ui.js', array('jquery'), '1.12.1', true);
            


            wp_enqueue_script('datalogics-shipping', add_query_arg( DATALOGICS_ARGS,plugins_url('/js/datalogics_shipping.js', __FILE__)));
            wp_localize_script('datalogics-shipping', 'object_data', 
                array(
                    'shipping_push_supplier' => get_option('shipping_push_supplier', ''), 
                    'ajax_url' => admin_url('admin-ajax.php'),
                    'datalogics_cities_auto' => get_option('datalogics_cities_auto','') ,
                    'datalogics_ncode_auto' =>  get_option('datalogics_ncode_auto','') ,
                )
            );

            $ncode_list = get_option('datalogics_shipping_locations');
            if ($ncode_list!='' && !is_array($ncode_list)) {
                
                $ncode_list = unserialize($ncode_list);
            }
            if ($ncode_list==''){
                $ncode_list = [];
            }

            $datalogics_ncode_list = [];

            foreach($ncode_list  as $platform_id=>$list) {

                foreach($list as $key=>$value) {
                    $datalogics_ncode_list[] = $key;
                }

            }
            wp_localize_script('datalogics-shipping', 'datalogics_ncode_list', $datalogics_ncode_list);

            wp_enqueue_style('datalogics-shipping', add_query_arg( DATALOGICS_ARGS,plugins_url('/css/style.css', __FILE__)));

            //$cities_streets_array = datalogics_get_cities_and_streets_data();
            //wp_localize_script('datalogics-shipping', 'datalogics_cities_and_streets_data', $cities_streets_array );

        }

    }

    add_action('wp_enqueue_scripts', 'enque_map');

    add_action('woocommerce_shipping_init', 'datalogics_pickup_shipping_method');

    function datalogics_pickup_shipping_method()
    {
        if (!class_exists('WC_Datalogics_door2door_Shipping_Method')) {
            class WC_Datalogics_door2door_Shipping_Method extends WC_Shipping_Method
            {

                public function __construct($instance_id = 0)
                {
                    $this->instance_id = absint($instance_id);
                    $this->id = 'datalogics_door2door';//this is the id of our shipping method
                    $this->method_title = __('Datalogics Door2Door Shipping', 'datalogics_shipping');
                    $this->method_description = __('Datalogics Door2Door', 'datalogics_shipping');
                    //add to shipping zones list
                    $this->supports = array(
                        'shipping-zones',
                        //'settings', //use this for separate settings page
                        'instance-settings',
                        'instance-settings-modal',
                    );
                    //make it always enabled

                    $this->title = __('Datalogics Door2Door Shipping', 'datalogics_shipping');
                    $this->enabled = 'yes';

                    $this->init();

                }

                function init()
                {
                    // Load the settings API
                    $this->init_form_fields();
                    $this->init_settings();

                    $this->tax_status  = $this->get_option( 'tax_status' );
                    $this->type        = $this->get_option( 'type', 'class' );

                    // Save settings in admin if you have any defined
                    add_action('woocommerce_update_options_shipping_' . $this->id, array($this, 'process_admin_options'));
                }

                //Fields for the settings page
                function init_form_fields()
                {

                    //fileds for the modal form from the Zones window
                    $this->instance_form_fields = array(

                        'title' => array(
                            'title' => __('Title', 'datalogics_shipping'),
                            'type' => 'text',
                            'description' => __('Title to be display on site', 'datalogics_shipping'),
                            'default' => __('Datalogics Door2Door', 'datalogics_shipping')
                        ),
                        'cost' => array(
                            'title' => __('Shipping Cost', 'datalogics_shipping'),
                            'type' => 'number',
                            'default' => 0
                        ),
                        'free' => array(
                            'title' => __('Free Shipping from', 'datalogics_shipping'),
                            'type' => 'number',
                            'default' => ''
                        )
                    );


                    $shipping_classes = WC()->shipping()->get_shipping_classes();

                    if ( ! empty( $shipping_classes ) ) {

                        $cost_desc = __( 'Enter a cost (excl. tax) or sum, e.g. <code>10.00 * [qty]</code>.', 'woocommerce' ) . '<br/><br/>' . __( 'Use <code>[qty]</code> for the number of items, <br/><code>[cost]</code> for the total cost of items, and <code>[fee percent="10" min_fee="20" max_fee=""]</code> for percentage based fees.', 'woocommerce' );


                        $this->instance_form_fields['class_costs'] = array(
                            'title'       => __( 'Shipping class costs', 'woocommerce' ),
                            'type'        => 'title',
                            'default'     => '',
                            /* translators: %s: URL for link. */
                            'description' => sprintf( __( 'These costs can optionally be added based on the <a href="%s">product shipping class</a>.', 'woocommerce' ), admin_url( 'admin.php?page=wc-settings&tab=shipping&section=classes' ) ),
                        );
                        foreach ( $shipping_classes as $shipping_class ) {
                            if ( ! isset( $shipping_class->term_id ) ) {
                                continue;
                            }

                            $this->instance_form_fields[ 'class_cost_' . $shipping_class->term_id ] = array(
                                /* translators: %s: shipping class name */
                                'title'             => sprintf( __( '"%s" shipping class cost', 'woocommerce' ), esc_html( $shipping_class->name ) ),
                                'type'              => 'text',
                                'placeholder'       => __( 'N/A', 'woocommerce' ),
                                'description'       => $cost_desc,
                                'default'           => $this->get_option( 'class_cost_' . $shipping_class->slug ), // Before 2.5.0, we used slug here which caused issues with long setting names.
                                'desc_tip'          => true,
                                'sanitize_callback' => array( $this, 'sanitize_cost' ),
                            );
                        }

                        $this->instance_form_fields['no_class_cost'] = array(
                            'title'             => __( 'No shipping class cost', 'woocommerce' ),
                            'type'              => 'text',
                            'placeholder'       => __( 'N/A', 'woocommerce' ),
                            'description'       => $cost_desc,
                            'default'           => '',
                            'desc_tip'          => true,
                            'sanitize_callback' => array( $this, 'sanitize_cost' ),
                        );

                        $this->instance_form_fields['type'] = array(
                            'title'   => __( 'Calculation type', 'woocommerce' ),
                            'type'    => 'select',
                            'class'   => 'wc-enhanced-select',
                            'default' => 'class',
                            'options' => array(
                                'class' => __( 'Per class: Charge shipping for each shipping class individually', 'woocommerce' ),
                                'order' => __( 'Per order: Charge shipping for the most expensive shipping class', 'woocommerce' ),
                            ),
                        );
                    }





                    $this->form_fields = array(

                        'enabled' => array(
                            'title' => __('Enable', 'datalogics_shipping'),
                            'type' => 'checkbox',
                            'description' => __('Enable this shipping.', 'datalogics_shipping'),
                            'default' => 'yes'
                        ),
                        'location_select' => array(
                            'title' => __('Show locations on:', 'datalogics_shipping'),
                            'type' => 'select',
                            'description' => __('List type for locations.', 'datalogics_shipping'),
                            'options' => array(
                                'map' => 'Map',
                                'list' => 'List'),
                            'default' => 'map'
                        ),
                        'title' => array(
                            'title' => __('Title', 'datalogics_shipping'),
                            'type' => 'text',
                            'description' => __('Title to be display on site', 'datalogics_shipping'),
                            'default' => __('Datalogics Shipping', 'datalogics_shipping')
                        )

                    );
                    //$this->form_fields - use this with the same array as above for setting fields for separate settings page
                }

                public function calculate_shipping($package = array())
                {

                    global $woocommerce;

                    //as we are using instances for the cost and the title we need to take those values drom the instance_settings
                    $intance_settings = $this->instance_settings;


                    $label = $intance_settings['title'];
                    $cost = $intance_settings['cost'];


                    $rate = array(
                        //'id'      => $this->get_rate_id(),//$this->id,
                        'id'      => $this->id,
                        'label'   => $label,
                        'cost'    => 0,
                        'package' => $package,
                    );



                    // Calculate the costs.
                    $has_costs = false; // True when a cost is set. False if all costs are blank strings.

                    if ( '' !== $cost ) {
                        $has_costs    = true;
                        $rate['cost'] = $this->evaluate_cost(
                            $cost,
                            array(
                                'qty'  => $this->get_package_item_qty( $package ),
                                'cost' => $package['contents_cost'],
                            )
                        );
                    }

                    // Add shipping class costs.
                    $shipping_classes = WC()->shipping()->get_shipping_classes();

                    if ( ! empty( $shipping_classes ) ) {
                        $found_shipping_classes = $this->find_shipping_classes( $package );
                        $highest_class_cost     = 0;

                        foreach ( $found_shipping_classes as $shipping_class => $products ) {
                            // Also handles BW compatibility when slugs were used instead of ids.
                            $shipping_class_term = get_term_by( 'slug', $shipping_class, 'product_shipping_class' );
                            $class_cost_string   = $shipping_class_term && $shipping_class_term->term_id ? $this->get_option( 'class_cost_' . $shipping_class_term->term_id, $this->get_option( 'class_cost_' . $shipping_class, '' ) ) : $this->get_option( 'no_class_cost', '' );

                            if ( '' === $class_cost_string ){
                                continue;
                            }

                            $has_costs  = true;
                            $class_cost = $this->evaluate_cost(
                                $class_cost_string,
                                array(
                                    'qty'  => array_sum( wp_list_pluck( $products, 'quantity' ) ),
                                    'cost' => array_sum( wp_list_pluck( $products, 'line_total' ) ),
                                )
                            );

                            if ( 'class' === $this->type ) {
                                $rate['cost'] += $class_cost;
                            } else {
                                $highest_class_cost = $class_cost > $highest_class_cost ? $class_cost : $highest_class_cost;
                            }
                        }

                        if ( 'order' === $this->type && $highest_class_cost ) {
                            $rate['cost'] += $highest_class_cost;
                        }
                    }


                    $sub_total = 0;

                    foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {


                        $sub_total = $sub_total + (float)$cart_item["line_total"];

                    }


                    if ((float)$intance_settings['free']>0 && (float)$sub_total>=(float)$intance_settings['free'])
                    {

                        $has_costs = true;
                        $cost = 0;

                        $label .= __('(Free shipping)','datalogics_shipping');

                        $rate['label'] = $label;
                        $rate['cost']  = $cost;

                    }



                    if ( $has_costs ) {

                        // Register the rate

                        $this->add_rate($rate);


//                        $this->add_rate(array(
//                                'id' => $this->id,
//                                'label' => $label,
//                                'cost' => $cost,
//                                'package' => $package,
//                                'taxes' => false,
//                            )
//                        );

                    }
                }


                /**
                 * Evaluate a cost from a sum/string.
                 *
                 * @param  string $sum Sum of shipping.
                 * @param  array  $args Args, must contain `cost` and `qty` keys. Having `array()` as default is for back compat reasons.
                 * @return string
                 */
                protected function evaluate_cost( $sum, $args = array() ) {
                    // Add warning for subclasses.
                    if ( ! is_array( $args ) || ! array_key_exists( 'qty', $args ) || ! array_key_exists( 'cost', $args ) ) {
                        wc_doing_it_wrong( __FUNCTION__, '$args must contain `cost` and `qty` keys.', '4.0.1' );
                    }

                    include_once WC()->plugin_path() . '/includes/libraries/class-wc-eval-math.php';

                    // Allow 3rd parties to process shipping cost arguments.
                    $args           = apply_filters( 'woocommerce_evaluate_shipping_cost_args', $args, $sum, $this );
                    $locale         = localeconv();
                    $decimals       = array( wc_get_price_decimal_separator(), $locale['decimal_point'], $locale['mon_decimal_point'], ',' );
                    $this->fee_cost = $args['cost'];

                    // Expand shortcodes.
                    add_shortcode( 'fee', array( $this, 'fee' ) );

                    $sum = do_shortcode(
                        str_replace(
                            array(
                                '[qty]',
                                '[cost]',
                            ),
                            array(
                                $args['qty'],
                                $args['cost'],
                            ),
                            $sum
                        )
                    );

                    remove_shortcode( 'fee', array( $this, 'fee' ) );

                    // Remove whitespace from string.
                    $sum = preg_replace( '/\s+/', '', $sum );

                    // Remove locale from string.
                    $sum = str_replace( $decimals, '.', $sum );

                    // Trim invalid start/end characters.
                    $sum = rtrim( ltrim( $sum, "\t\n\r\0\x0B+*/" ), "\t\n\r\0\x0B+-*/" );

                    // Do the math.
                    return $sum ? WC_Eval_Math::evaluate( $sum ) : 0;
                }


                /**
                 * Get items in package.
                 *
                 * @param  array $package Package of items from cart.
                 * @return int
                 */
                public function get_package_item_qty( $package ) {
                    $total_quantity = 0;
                    foreach ( $package['contents'] as $item_id => $values ) {
                        if ( $values['quantity'] > 0 && $values['data']->needs_shipping() ) {
                            $total_quantity += $values['quantity'];
                        }
                    }
                    return $total_quantity;
                }

                /**
                 * Finds and returns shipping classes and the products with said class.
                 *
                 * @param mixed $package Package of items from cart.
                 * @return array
                 */
                public function find_shipping_classes( $package ) {
                    $found_shipping_classes = array();

                    foreach ( $package['contents'] as $item_id => $values ) {
                        if ( $values['data']->needs_shipping() ) {
                            $found_class = $values['data']->get_shipping_class();

                            if ( ! isset( $found_shipping_classes[ $found_class ] ) ) {
                                $found_shipping_classes[ $found_class ] = array();
                            }

                            $found_shipping_classes[ $found_class ][ $item_id ] = $values;
                        }
                    }

                    return $found_shipping_classes;
                }

                /**
                 * Sanitize the cost field.
                 *
                 * @since 3.4.0
                 * @param string $value Unsanitized value.
                 * @throws Exception Last error triggered.
                 * @return string
                 */
                public function sanitize_cost( $value ) {
                    $value = is_null( $value ) ? '' : $value;
                    $value = wp_kses_post( trim( wp_unslash( $value ) ) );
                    $value = str_replace( array( get_woocommerce_currency_symbol(), html_entity_decode( get_woocommerce_currency_symbol() ) ), '', $value );
                    // Thrown an error on the front end if the evaluate_cost will fail.
                    $dummy_cost = $this->evaluate_cost(
                        $value,
                        array(
                            'cost' => 1,
                            'qty'  => 1,
                        )
                    );
                    if ( false === $dummy_cost ) {
                        throw new Exception( WC_Eval_Math::$last_error );
                    }
                    return $value;
                }
            }

        }
        if (!class_exists('WC_Datalogics_pickup_Shipping_Method')) {
            class WC_Datalogics_pickup_Shipping_Method extends WC_Shipping_Method
            {

                public function __construct($instance_id = 0)
                {
                    $this->instance_id = absint($instance_id);
                    $this->id = 'datalogics_pickup';//this is the id of our shipping method
                    $this->method_title = __('Datalogics Pickup Shipping', 'datalogics_shipping');
                    $this->method_description = __('Datalogics Pickup', 'datalogics_shipping');
                    //add to shipping zones list
                    $this->supports = array(
                        'shipping-zones',
                        //'settings', //use this for separate settings page
                        'instance-settings',
                        'instance-settings-modal',
                    );
                    //make it always enabled

                    $this->title = __('Datalogics Pickup Shipping', 'datalogics_shipping');
                    $this->enabled = 'yes';

                    $this->init();

                    //var_dump('instance_id',$this);

                }

                function init()
                {
                    // Load the settings API
                    $this->init_form_fields();
                    $this->init_settings();

                    $this->tax_status  = $this->get_option( 'tax_status' );
                    $this->type        = $this->get_option( 'type', 'class' );

                    // Save settings in admin if you have any defined
                    add_action('woocommerce_update_options_shipping_' . $this->id, array($this, 'process_admin_options'));
                }

                //Fields for the settings page
                function init_form_fields()
                {

                    //fileds for the modal form from the Zones window
                    $this->instance_form_fields = array(

                        'title' => array(
                            'title' => __('Title', 'datalogics_shipping'),
                            'type' => 'text',
                            'description' => __('Title to be display on site', 'datalogics_shipping'),
                            'default' => __('Datalogics Pickup', 'datalogics_shipping')
                        ),
                        'cost' => array(
                            'title' => __('Shipping Cost', 'datalogics_shipping'),
                            'type' => 'number',
                            'default' => 0
                        ),
                        'free' => array(
                            'title' => __('Free Shipping from', 'datalogics_shipping'),
                            'type' => 'number',
                            'default' => ''
                        )
                    );

                    $shipping_classes = WC()->shipping()->get_shipping_classes();

                    if ( ! empty( $shipping_classes ) ) {

                        $cost_desc = __( 'Enter a cost (excl. tax) or sum, e.g. <code>10.00 * [qty]</code>.', 'woocommerce' ) . '<br/><br/>' . __( 'Use <code>[qty]</code> for the number of items, <br/><code>[cost]</code> for the total cost of items, and <code>[fee percent="10" min_fee="20" max_fee=""]</code> for percentage based fees.', 'woocommerce' );


                        $this->instance_form_fields['class_costs'] = array(
                            'title'       => __( 'Shipping class costs', 'woocommerce' ),
                            'type'        => 'title',
                            'default'     => '',
                            /* translators: %s: URL for link. */
                            'description' => sprintf( __( 'These costs can optionally be added based on the <a href="%s">product shipping class</a>.', 'woocommerce' ), admin_url( 'admin.php?page=wc-settings&tab=shipping&section=classes' ) ),
                        );
                        foreach ( $shipping_classes as $shipping_class ) {
                            if ( ! isset( $shipping_class->term_id ) ) {
                                continue;
                            }

                            $this->instance_form_fields[ 'class_cost_' . $shipping_class->term_id ] = array(
                                /* translators: %s: shipping class name */
                                'title'             => sprintf( __( '"%s" shipping class cost', 'woocommerce' ), esc_html( $shipping_class->name ) ),
                                'type'              => 'text',
                                'placeholder'       => __( 'N/A', 'woocommerce' ),
                                'description'       => $cost_desc,
                                'default'           => $this->get_option( 'class_cost_' . $shipping_class->slug ), // Before 2.5.0, we used slug here which caused issues with long setting names.
                                'desc_tip'          => true,
                                'sanitize_callback' => array( $this, 'sanitize_cost' ),
                            );
                        }

                        $this->instance_form_fields['no_class_cost'] = array(
                            'title'             => __( 'No shipping class cost', 'woocommerce' ),
                            'type'              => 'text',
                            'placeholder'       => __( 'N/A', 'woocommerce' ),
                            'description'       => $cost_desc,
                            'default'           => '',
                            'desc_tip'          => true,
                            'sanitize_callback' => array( $this, 'sanitize_cost' ),
                        );

                        $this->instance_form_fields['type'] = array(
                            'title'   => __( 'Calculation type', 'woocommerce' ),
                            'type'    => 'select',
                            'class'   => 'wc-enhanced-select',
                            'default' => 'class',
                            'options' => array(
                                'class' => __( 'Per class: Charge shipping for each shipping class individually', 'woocommerce' ),
                                'order' => __( 'Per order: Charge shipping for the most expensive shipping class', 'woocommerce' ),
                            ),
                        );
                    }


                    $this->form_fields = array(

                        'enabled' => array(
                            'title' => __('Enable', 'datalogics_shipping'),
                            'type' => 'checkbox',
                            'description' => __('Enable this shipping.', 'datalogics_shipping'),
                            'default' => 'yes'
                        ),
                        'location_select' => array(
                            'title' => __('Show locations on:', 'datalogics_shipping'),
                            'type' => 'select',
                            'description' => __('List type for locations.', 'datalogics_shipping'),
                            'options' => array(
                                'map' => 'Map',
                                'list' => 'List'),
                            'default' => 'map'
                        ),
                        'title' => array(
                            'title' => __('Title', 'datalogics_shipping'),
                            'type' => 'text',
                            'description' => __('Title to be display on site', 'datalogics_shipping'),
                            'default' => __('Datalogics Shipping', 'datalogics_shipping')
                        )

                    );
                    //$this->form_fields - use this with the same array as above for setting fields for separate settings page
                }

                public function calculate_shipping($package = array())
                {

                    

                    global $woocommerce;

                    //as we are using instances for the cost and the title we need to take those values drom the instance_settings
                    $intance_settings = $this->instance_settings;

                    $label = $intance_settings['title'];
                    $cost = $intance_settings['cost'];


                    $rate = array(
                        //'id'      => $this->get_rate_id(),//$this->id,
                        'id'      => $this->id,
                        'label'   => $label,
                        'cost'    => 0,
                        'package' => $package,
                    );

                    



                    // Calculate the costs.
                    $has_costs = false; // True when a cost is set. False if all costs are blank strings.

                    if ( '' !== $cost ) {
                        $has_costs    = true;
                        $rate['cost'] = $this->evaluate_cost(
                            $cost,
                            array(
                                'qty'  => $this->get_package_item_qty( $package ),
                                'cost' => $package['contents_cost'],
                            )
                        );
                    }

                    // Add shipping class costs.
                    $shipping_classes = WC()->shipping()->get_shipping_classes();

                    if ( ! empty( $shipping_classes ) ) {
                        $found_shipping_classes = $this->find_shipping_classes( $package );
                        $highest_class_cost     = 0;

                        foreach ( $found_shipping_classes as $shipping_class => $products ) {
                            // Also handles BW compatibility when slugs were used instead of ids.
                            $shipping_class_term = get_term_by( 'slug', $shipping_class, 'product_shipping_class' );
                            $class_cost_string   = $shipping_class_term && $shipping_class_term->term_id ? $this->get_option( 'class_cost_' . $shipping_class_term->term_id, $this->get_option( 'class_cost_' . $shipping_class, '' ) ) : $this->get_option( 'no_class_cost', '' );

                            if ( '' === $class_cost_string ) {
                                continue;
                            }

                            $has_costs  = true;
                            $class_cost = $this->evaluate_cost(
                                $class_cost_string,
                                array(
                                    'qty'  => array_sum( wp_list_pluck( $products, 'quantity' ) ),
                                    'cost' => array_sum( wp_list_pluck( $products, 'line_total' ) ),
                                )
                            );

                            if ( 'class' === $this->type ) {
                                $rate['cost'] += $class_cost;
                            } else {
                                $highest_class_cost = $class_cost > $highest_class_cost ? $class_cost : $highest_class_cost;
                            }
                        }

                        if ( 'order' === $this->type && $highest_class_cost ) {
                            $rate['cost'] += $highest_class_cost;
                        }
                    }


                    $sub_total = 0;


                    foreach ( WC()->cart->get_cart() as $cart_item_key => $cart_item ) {

                        $product_id = (int)$cart_item['product_id'];

                        //var_dump($cart_item);

                        if ($product_id>0) {

                            $datalogics_pickup_allowed = 'datalogics_pickup_allowed';

                            $check_allowed_value = get_post_meta($product_id, $datalogics_pickup_allowed, true);


                            if ($check_allowed_value==1)
                            {
                                return false;
                            }

                        }

                        $sub_total = $sub_total + (float)$cart_item["line_total"];

                    }


                    if ((float)$intance_settings['free']>0 && (float)$sub_total>=(float)$intance_settings['free'])
                    {

                        $has_costs = true;
                        $cost = 0;

                        $label .= __('(Free shipping)','datalogics_shipping');

                        $rate['label'] = $label;
                        $rate['cost']  = $cost;

                    }



                    if ( $has_costs ) {

                        // Register the rate

                        $this->add_rate($rate);


//                        $this->add_rate(array(
//                                'id' => $this->id,
//                                'label' => $label,
//                                'cost' => $cost,
//                                'package' => $package,
//                                'taxes' => false,
//                            )
//                        );

                    }
                }


                /**
                 * Evaluate a cost from a sum/string.
                 *
                 * @param  string $sum Sum of shipping.
                 * @param  array  $args Args, must contain `cost` and `qty` keys. Having `array()` as default is for back compat reasons.
                 * @return string
                 */
                protected function evaluate_cost( $sum, $args = array() ) {
                    // Add warning for subclasses.
                    if ( ! is_array( $args ) || ! array_key_exists( 'qty', $args ) || ! array_key_exists( 'cost', $args ) ) {
                        wc_doing_it_wrong( __FUNCTION__, '$args must contain `cost` and `qty` keys.', '4.0.1' );
                    }

                    include_once WC()->plugin_path() . '/includes/libraries/class-wc-eval-math.php';

                    // Allow 3rd parties to process shipping cost arguments.
                    $args           = apply_filters( 'woocommerce_evaluate_shipping_cost_args', $args, $sum, $this );
                    $locale         = localeconv();
                    $decimals       = array( wc_get_price_decimal_separator(), $locale['decimal_point'], $locale['mon_decimal_point'], ',' );
                    $this->fee_cost = $args['cost'];

                    // Expand shortcodes.
                    add_shortcode( 'fee', array( $this, 'fee' ) );

                    $sum = do_shortcode(
                        str_replace(
                            array(
                                '[qty]',
                                '[cost]',
                            ),
                            array(
                                $args['qty'],
                                $args['cost'],
                            ),
                            $sum
                        )
                    );

                    remove_shortcode( 'fee', array( $this, 'fee' ) );

                    // Remove whitespace from string.
                    $sum = preg_replace( '/\s+/', '', $sum );

                    // Remove locale from string.
                    $sum = str_replace( $decimals, '.', $sum );

                    // Trim invalid start/end characters.
                    $sum = rtrim( ltrim( $sum, "\t\n\r\0\x0B+*/" ), "\t\n\r\0\x0B+-*/" );

                    // Do the math.
                    return $sum ? WC_Eval_Math::evaluate( $sum ) : 0;
                }


                /**
                 * Get items in package.
                 *
                 * @param  array $package Package of items from cart.
                 * @return int
                 */
                public function get_package_item_qty( $package ) {
                    $total_quantity = 0;
                    foreach ( $package['contents'] as $item_id => $values ) {
                        if ( $values['quantity'] > 0 && $values['data']->needs_shipping() ) {
                            $total_quantity += $values['quantity'];
                        }
                    }
                    return $total_quantity;
                }

                /**
                 * Finds and returns shipping classes and the products with said class.
                 *
                 * @param mixed $package Package of items from cart.
                 * @return array
                 */
                public function find_shipping_classes( $package ) {
                    $found_shipping_classes = array();

                    foreach ( $package['contents'] as $item_id => $values ) {
                        if ( $values['data']->needs_shipping() ) {
                            $found_class = $values['data']->get_shipping_class();

                            if ( ! isset( $found_shipping_classes[ $found_class ] ) ) {
                                $found_shipping_classes[ $found_class ] = array();
                            }

                            $found_shipping_classes[ $found_class ][ $item_id ] = $values;
                        }
                    }

                    return $found_shipping_classes;
                }

                /**
                 * Sanitize the cost field.
                 *
                 * @since 3.4.0
                 * @param string $value Unsanitized value.
                 * @throws Exception Last error triggered.
                 * @return string
                 */
                public function sanitize_cost( $value ) {
                    $value = is_null( $value ) ? '' : $value;
                    $value = wp_kses_post( trim( wp_unslash( $value ) ) );
                    $value = str_replace( array( get_woocommerce_currency_symbol(), html_entity_decode( get_woocommerce_currency_symbol() ) ), '', $value );
                    // Thrown an error on the front end if the evaluate_cost will fail.
                    $dummy_cost = $this->evaluate_cost(
                        $value,
                        array(
                            'cost' => 1,
                            'qty'  => 1,
                        )
                    );
                    if ( false === $dummy_cost ) {
                        throw new Exception( WC_Eval_Math::$last_error );
                    }
                    return $value;
                }
            }
        }

        //add your shipping method to WooCommers list of Shipping methods
        add_filter('woocommerce_shipping_methods', 'add_datalogics_pickup_shipping_method');

        if (!function_exists('add_datalogics_pickup_shipping_method')) {

            function add_datalogics_pickup_shipping_method($methods)
            {
                //var_dump($methods);
                $methods['datalogics_pickup'] = 'WC_Datalogics_pickup_Shipping_Method';
                $methods['datalogics_door2door'] = 'WC_Datalogics_door2door_Shipping_Method';
                return $methods;
            }

        }
    }

    add_action('woocommerce_after_checkout_form', 'add_checkout_datalogics_popup', 10, 2);

    function add_checkout_datalogics_popup()
    {

        $datalogics_google_key = get_option('datalogics_google_key', '');
        $datalogics_view_option = get_option('datalogics_view_option','');

        $existing_companies = get_option('datalogics_shipping_method', '');
        $existing_companies = json_decode($existing_companies,true); 

        $locations = get_option('datalogics_shipping_locations');
        if (is_string($locations) && $locations!='') {
            $locations = unserialize($locations);
        }

        ?>
        <div class="datalogics_pickup_checkout">
            <div class="datalogics_pickup_checkout_inner<?php if ($datalogics_view_option == 2) { ?> list-only<?php } ?>">
                <div class="datalogics_pickup_checkout_top">
                    <div class="datalogics_pickup_checkout_close">x</div>
                    <div class="datalogics_pickup_checkout_logo logo<?php echo get_option('shipping_push_supplier', '') ?>"></div>
                    
                    <div class="datalogics_pickup_checkout_input<?php if ($datalogics_view_option == 2) { ?> list-only<?php } ?>">
                        <input type="text" id="datalogics-location-input"
                               placeholder="<?php echo __('Please fill your address..', 'datalogics_shipping') ?>">
                        <button class="datalogics_pickup_locate_button"><?php echo __('locate', 'datalogics_shipping') ?></button>
                    </div>
                    
                </div>
                <div class="datalogics_pickup_checkout_top2">
                    <?php if ($datalogics_view_option == 0 || $datalogics_view_option == 2) { ?>
                    <div class="datalogics_pickup_checkout_top2_button<?php if ($datalogics_view_option == 2) { ?> datal-fullw<?php } ?>"
                         data-action="list"><?php echo __('list', 'datalogics_shipping') ?></div>
                    <?php } ?>
                    <?php if ($datalogics_view_option == 0 || $datalogics_view_option == 1) { ?>
                    <div class="datalogics_pickup_checkout_top2_button<?php if ($datalogics_view_option == 1) { ?> datal-fullw<?php } ?>"
                         data-action="map"><?php echo __('map', 'datalogics_shipping') ?></div>
                    <?php } ?>
                </div>
                <div class="datalogics_pickup_checkout_mid">
                    <div class="datalogics_pickup_checkout_mid_notice"><?php echo __('Showing 20 stores closed to your location', 'datalogics_shipping') ?></div>
                    <div class="datalogics_pickup_checkout_mid_list">
                        <div class="datalogics_pickup_checkout_msg"><?php echo __('Please fill your address on the search field', 'datalogics_shipping') ?></div>
                        <?php if ($datalogics_google_key=='') { ?>
                            <?php
                            
                            foreach ($locations as $platform_id => $values){

                                $company_exist_check = false;
                            
                                foreach($existing_companies as $exist_company) {

                                    if ($exist_company['shipping_push_supplier']==$platform_id) {

                                        $company_exist_check = true;

                                    }

                                }

                                if ($company_exist_check == false) {
                                    continue;
                                }

                                foreach ($values as $key => $value) {

                                    //$mylat = (float)'32.085300';
                                    //$mylong = (float)'34.781769';
                                    //$deslat = (float)$value['latitude'];
                                    //$deslong = (float)$value['longitude'];

                                    $value['n_code'] = (!isset($value['n_code'])) ? '' : $value['n_code'];
                                    if ($value['n_code']=='') {
                                        continue;
                                    }
                                    $value['city'] = (!isset($value['city'])) ? '' : $value['city'];
                                    $value['street'] = (!isset($value['street'])) ? '' : $value['street'];
                                    $value['house'] = (!isset($value['house'])) ? '' : $value['house'];
                                    $value['name'] = (!isset($value['name'])) ? '' : $value['name'];
                                    


                                    //$distance = Distance($mylat,$mylong,$deslat,$deslong);

                                    //$distance = number_format((float)$distance, 2, '.', '');
                                    $distance = '';
                                    ?>
                                    <div class="datalogics_pickup_checkout_mid_list_row list-icon list-icon17" data-ncode="<?php echo sanitize_text_field($value['n_code']) ?>"
                                        onclick="selectLocation('<?php echo sanitize_text_field(str_replace('"','',$value['name'])) ?>','<?php echo sanitize_text_field($value['street']) ?>','<?php echo sanitize_text_field($value['house']) ?>','<?php echo sanitize_text_field($value['city']) ?>','<?php echo sanitize_text_field($value['n_code']) ?>')">
                                        <strong><?php echo $value['name'] ?></strong><br>
                                        <?php echo $value['street'] ?> <?php echo $value['house'] ?>
                                        ,<?php echo $value['city'] ?>.<br>
                                        <?php if ($distance!='') { ?>
                                        <?php echo __('Distance from destination','datalogics_shipping')?> <?php echo $distance;?><?php echo __('km','datalogics')?>
                                        <?php } ?>
                                        <button class="button"><?php echo __('Choose Location','datalogics_shipping')?></button>
                                    </div>
                                    <?php
                                }
                            }   
                        }                     
                        ?>
                    </div>
                    <?php if ($datalogics_view_option == 0 || $datalogics_view_option == 1) { ?>
                    <div id="datalogics-map" class="datalogics_pickup_checkout_mid_map">
                    </div>
                    <?php } ?>
                </div>
            </div>
        </div>
        <?php

    }

    add_action('woocommerce_after_shipping_rate', 'add_checkout_item_pickup_location_field', 20, 2);

    function add_checkout_item_pickup_location_field($method, $index)
    {

        if (is_checkout()) {
            $chosen_methods = WC()->session->get('chosen_shipping_methods');
            $chosen_shipping = $chosen_methods[0];
            //var_dump($chosen_shipping);
            if ($chosen_shipping == 'datalogics_pickup' && $method->get_id() == 'datalogics_pickup') {
                //$datalogics_method = new WC_Datalogics_pickup_Shipping_Method;

                //$locations = unserialize(get_option('datalogics_shipping_locations'));
                //$datalogics_method = new WC_Datalogics_pickup_Shipping_Method();
                //$location_select = get_option('datalogics_location_select', 'map');
                $existing_companies = get_option('datalogics_shipping_method', '');
                $existing_companies = json_decode($existing_companies,true); 

                $datalogics_view_option = get_option('datalogics_view_option','');                
                ?>
                <p id="datalogics_pickup_cities_message"></p>
                <?php 
                if ($datalogics_view_option == 0 || $datalogics_view_option == 1) {
                ?>
                <span id="datalogics-choose-location" class="datalogics-choose-location">
                    <span class="datalogics-choose-location-icon"></span>
                    <span class="datalogics-choose-location-text"><?php echo __('Choose Location', 'datalogics_shipping') ?></span>
                </span>
                <?php
                } else {
                    //$ncode_list = unserialize(get_option('datalogics_shipping_locations'));
                    $ncode_list = get_option('datalogics_shipping_locations');
                    if ($ncode_list!='' && !is_array($ncode_list)) {
                        $ncode_list = unserialize($ncode_list);
                    }
                    if ($ncode_list==''){
                        $ncode_list = [];
                    }                    
                    $datalogics_n_code = '';

                    if (!empty($ncode_list)) {

                        $cities = [];
                        if (get_option('datalogics_ncode_auto')) {
                        ?>
                        <div class="datalogics-n-city-con">
                            <label for="datalogics_n_code_city_select"><?php echo __('Please fill pickup city', 'datalogics_shipping') ?></label>
                            <input id="datalogics_n_code_city_select" type="text">
                        </div>                        
                        <?php
                        } else {                        
                        ?>  
                        <select id="datalogics_n_code_city_select">
                        <option value="">בחירת עיר</option>
                        <?php
                        
                        foreach ($ncode_list as $platform_id => $locations){
                            
                            $company_exist_check = false;
                            
                            foreach($existing_companies as $exist_company) {

                                if ($exist_company['shipping_push_supplier']==$platform_id) {

                                    $company_exist_check = true;

                                }

                            }

                            if ($company_exist_check == false) {
                                continue;
                            }

                            foreach ($locations as $city=>$values){
                                if (!in_array($city,$cities)) {
                                    $cities[] = $city;                                
                                }
                            }
                        }    
                        sort($cities);                
                        foreach($cities as $city) {
                            ?>                            
                            <option data-city="<?php echo $city?>"><?php echo $city?></option>                            
                            <?php
                        }
                        ?>
                        </select>
                        <?php
                        }
                        ?>
                        <select id="datalogics_n_code_select" name="datalogics_n_code">        
                            <option value="">בחירת נקודת חלוקה</option>
                        <?php
                        $final_ncode_list = [];
                        foreach ($ncode_list as $platform_id => $locations){   
                            
                            $company_exist_check = false;
                            
                            foreach($existing_companies as $exist_company) {

                                if ($exist_company['shipping_push_supplier']==$platform_id) {

                                    $company_exist_check = true;

                                }

                            }

                            if ($company_exist_check == false) {
                                continue;
                            }


                            
                            foreach ($locations as $city=>$values){
                                foreach($values as $value) {

                                    $value['n_code'] = (!isset($value['n_code'])) ? '' : $value['n_code'];
                                    if ($value['n_code']=='') {
                                        continue;
                                    }
                                    $value['city'] = (!isset($value['city'])) ? '' : $value['city'];
                                    $value['street'] = (!isset($value['street'])) ? '' : $value['street'];
                                    $value['house'] = (!isset($value['house'])) ? '' : $value['house'];
                                    $value['name'] = (!isset($value['name'])) ? '' : $value['name'];
                                    $value['platform_id'] = $platform_id;

                                    if ($value['name']=='') {
                                        continue;
                                    }

                                    $final_ncode_list[$value['name']] = $value;
                                }
                            }
                        }

                        ksort($final_ncode_list);
                        foreach($final_ncode_list  as $value) {
                            
                            $platform_id = $value['platform_id'];
                            $city = $value['city'];
                            
                            ?>
                            <option class="datalogics-hide-option" data-city="<?php echo $city?>" data-platform-id="<?php echo $platform_id?>" value="<?php echo $platform_id.'-'.$value['n_code']?>"><?php echo $value['name']?>, <?php echo $value['street']?> <?php echo $value['house']?>, <?php echo $value['city']?></option>
                            <?php
                        }
                        ?>
                        </select>              
                    <?php                        
                    }
                }
            }
        }
    }


    //Validating that location is selected
    add_action('woocommerce_after_checkout_validation', 'datalogics_validate_location', 10, 2);

    function datalogics_validate_location($fields, $errors)
    {
        $chosen_methods = WC()->session->get('chosen_shipping_methods');
        $chosen_shipping = $chosen_methods[0];
        
        if ($_POST['datalogics_n_code']=='' && $chosen_shipping=='datalogics_pickup') 
        {
            $validation = __('You did not choose pickup location. <a href="#datalogics-choose-location">Click here to choose your pickup location.</a>', 'datalogics_shipping');
            $errors->add('validation', $validation);
        }
    }


// Outputting the hidden field in checkout page
    add_action('woocommerce_after_order_notes', 'add_datalogics_n_code');
    function add_datalogics_n_code($checkout)
    {
        // Output the hidden field
        $datalogics_view_option = get_option('datalogics_view_option','');                
        if ($datalogics_view_option == 0 || $datalogics_view_option == 1) {
            echo '<input type="hidden" name="datalogics_n_code" id="datalogics_n_code" value="">';
        }
        echo '<input type="hidden" name="datalogics_n_code_platform_id" id="datalogics_n_code_platform_id" value="">';
    }

    // Saving the hidden field value in the order metadata
    add_action('woocommerce_checkout_update_order_meta', 'save_datalogics_n_code');
    function save_datalogics_n_code($order_id)
    {
        $chosen_methods = WC()->session->get('chosen_shipping_methods');
        $chosen_shipping = $chosen_methods[0];
        if (!empty($_POST['datalogics_n_code']) && $chosen_shipping == 'datalogics_pickup') {
            update_post_meta($order_id, 'datalogics_n_code', sanitize_text_field($_POST['datalogics_n_code']));
            update_post_meta($order_id, 'datalogics_n_code_platform_id', sanitize_text_field($_POST['datalogics_n_code_platform_id']));
        }
    }


    /**
     * Calculates the great-circle distance between two points, with
     * the Vincenty formula.
     * @param float $latitudeFrom Latitude of start point in [deg decimal]
     * @param float $longitudeFrom Longitude of start point in [deg decimal]
     * @param float $latitudeTo Latitude of target point in [deg decimal]
     * @param float $longitudeTo Longitude of target point in [deg decimal]
     * @param float $earthRadius Mean earth radius in [m]
     * @return float Distance between points in [m] (same as earthRadius)
     */
    function vincentyGreatCircleDistance(
        $latitudeFrom, $longitudeFrom, $latitudeTo, $longitudeTo, $earthRadius = 6371000)
    {
        // convert from degrees to radians
        $latFrom = deg2rad($latitudeFrom);
        $lonFrom = deg2rad($longitudeFrom);
        $latTo = deg2rad($latitudeTo);
        $lonTo = deg2rad($longitudeTo);

        $lonDelta = $lonTo - $lonFrom;
        $a = pow(cos($latTo) * sin($lonDelta), 2) +
            pow(cos($latFrom) * sin($latTo) - sin($latFrom) * cos($latTo) * cos($lonDelta), 2);
        $b = sin($latFrom) * sin($latTo) + cos($latFrom) * cos($latTo) * cos($lonDelta);

        $angle = atan2(sqrt($a), $b);
        return $angle * $earthRadius;
    }

    function Distance($lat1, $lon1, $lat2, $lon2, $unit = 'K')
    {

        $theta = $lon1 - $lon2;
        $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) + cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
        $dist = acos($dist);
        $dist = rad2deg($dist);
        $miles = $dist * 60 * 1.1515;
        $unit = strtoupper($unit);

        if ($unit == "K") {
            return ($miles * 1.609344);
        } else if ($unit == "N") {
            return ($miles * 0.8684);
        } else {
            return $miles;
        }
    }

}

