<?php

function tracking_custom_body_class( array $classes ) {

	$new_class = is_page() ? get_post_meta( get_the_ID(), 'tracking_page', true ) : null;

	if ( $new_class ) {
		$classes[] = $new_class;
	}

	return $classes;
}

add_shortcode( 'datalogics_shipping_tracker', 'datalogics_shipping_tracker' );

function datalogics_shipping_tracker() {

    add_filter( 'body_class', 'tracking_custom_body_class' );

    wp_enqueue_style('datalogics-tracking-plugin-style', add_query_arg( DATALOGICS_ARGS,plugins_url( '/css/tracking.css', __FILE__ ) ));
    //wp_enqueue_script( 'datalogics-tracking-scripts',  plugins_url( '/js/scripts.js', __FILE__ ) );

    ?>
    <script type="text/javascript">

        

        let admin_url = "<?php echo admin_url( 'admin-ajax.php' )?>";
        
        jQuery(document).ready(function(){

            let loader = jQuery(".datalogics_loader");


            jQuery(".tracking_cells_last").on("click",function(){

                let button = jQuery(this);
                let parent = button.closest(".tracking_cells");
                if (button.hasClass("open")) {

                    button.removeClass("open")
                    parent.next(".big").hide(0);

                } else {

                    button.addClass("open")
                    parent.next(".big").css("display","table-row");

                }

            })

            let tracking = '<?php if (isset($_GET['tracking'])) { echo $_GET['tracking']; }?>';
            let order = '<?php if (isset($_GET['order'])) { echo $_GET['order']; }?>';

            if (tracking!='' && order!='') {
                SearchTracking(order,tracking) ;
            }

            jQuery(".tracking-search-button").on("click",function(){

                let parent = jQuery(".tracking-search-box");
                let order_no = parent.find("#order_no").val();
                let shipping_no = parent.find("#shipping_no").val();       
                SearchTracking(order_no,shipping_no) ;        

            })



            function SearchTracking(order_no,shipping_no) {

                loader.show(1);  

                let parent = jQuery(".tracking-search-box");

                let postData = {
                    action : 'datalogics_track_shipping',
                    order_no : order_no,
                    shipping_no : shipping_no
                }

                jQuery.ajax(admin_url, {
                    type: 'POST',
                    data: postData,
                    success: function (data, status, xhr) {


                        loader.hide(0);

                        var result = data;                        

                        //parent.find(".tracking-history").hide(0);

                        if (result.success == 1) {

                            parent.find(".tracking-search-box-result").show(0);
                            parent.find(".tracking-search-box-not-found").hide(0);
                            
                            parent.find(".tracking-search-box-result-order-title-id").text(order_no);
                            parent.find(".tracking-search-box-result-order-title-name").text(result.firstname + ' ' + result.lastname);
                            parent.find(".tracking-search-box-result-order-title-address").text(result.address1 + ' ' + result.address2 + ' ' + result.city);
                            parent.find(".tracking-search-box-result-order-title-value").text(result.total);
                            //parent.find(".tracking-search-box-result-order-title-items").text(order_no);
                            parent.find(".tracking-search-box-result-order-title-date").text(result.date);
                            //parent.find(".tracking-search-box-result-order-title-arrival").text(result.date);
                            //parent.find(".tracking-search-box-result-order-status").text(result.status);

                            
                            let history = parent.find(".tracking-history");
                            let history_box = history.find(".tracking-history-step.hidden")[0];

                            history.find(".tracking-history-step.hidden").find(".tracking-history-date").text(result.date);

                            let lastStatus = '';                            
                            
                            for(let key in result.status) {

                                let history_box_clone = jQuery(history_box).clone();
                                history_box_clone.removeClass("hidden");
                                history_box_clone.find(".tracking-history-status").text(result.status[key].status)
                                history_box_clone.find(".tracking-history-date").text(result.status[key].date)
                                history.append(history_box_clone);

                                lastStatus = result.status[key].status

                            }

                            if (lastStatus=='') {
                                lastStatus = "<?php echo __('Order in the system','datalogics_shipping')?>";
                            }

                            parent.find(".tracking-search-box-result-order-status").text(lastStatus);

                            // if (result.status.length>0) {
                            //     parent.find(".tracking-history").show(0);
                            // }

                        }
                        else {

                            parent.find(".tracking-search-box-result").hide(0);
                            parent.find(".tracking-search-box-not-found").show(0);
                            

                            //error.html(result.msg)
                        }

                        

                    },
                    error: function (jqXhr, textStatus, errorMessage) {
                        console.log(textStatus);
                    }
                });
            }

        })

        
    </script>

    <div class="tracking-box">        
        <div class="tracking-search">
            <div class="tracking-search-title">
                <?php echo __('Search for any package with your order number or shipping number.','datalogics_shipping')?>                
            </div>
            <div class="tracking-search-box">

                <div style="display:none" class="datalogics_loader"></div>

                <div>
                    <label for="order_no"><?php echo __('Order No.','datalogics_shipping')?></label>
                    <input type="text" id="order_no">
                </div>
                <div>
                    <label for="shipping_no"><?php echo __('Shipping No.','datalogics_shipping')?></label>
                    <input type="text" id="shipping_no">
                </div>
                <div>
                    <button type="button" class="tracking-search-button"><?php echo __('Search','datalogics_shipping')?></button>
                </div>
                <div class="tracking-search-box-not-found">
                    <?php echo __('There is not shipping match your order number and shipping ID','datalogics_shipping')?>
                </div>
                <div class="tracking-search-box-result">
                    <div class="tracking-search-box-result-order">
                        <strong class="tracking-search-box-result-order-title">
                            <?php echo __('Order No.','datalogics_shipping')?>:
                            <span class="tracking-search-box-result-order-title-id"></span>                    
                        </strong>
                        <span class="tracking-search-box-result-order-status"></span>
                    </div>
                    <div class="tracking-search-box-result-details">
                        <div class="tracking-search-box-result-details-title">
                            <?php echo __('Shipping Details','datalogics_shipping')?>
                        </div>
                        <div class="tracking-search-box-result-details-box">
                            <div>
                                <div>
                                    <div><?php echo __('Recipient','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-name"></div>
                                </div>
                                <div>
                                    <div><?php echo __('Delivery Address','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-address"></div>
                                </div>
                                <div>
                                    <div><?php echo __('Order Placed','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-date"></div>
                                </div>                                
                            </div>
                            <div>
                                <div>
                                    <div><?php echo __('Order Value','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-value"></div>
                                </div>
                                <div>
                                    <div><?php echo __('No. of Items','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-items">-</div>
                                </div>                                
                                <?php /*
                                <div>
                                    <div><?php echo __('Delivery Date','datalogics_shipping')?>:</div>
                                    <div class="tracking-search-box-result-order-title-arrival"></div>
                                </div>  
                                */
                                ?>        
                            </div>
                        </div>             
                    </div>

                    <div class="tracking-history">

                        <div><strong class="tracking-history-title"><?php echo __('Order History','datalogics_shipping')?></strong></div>
                        <div class="tracking-history-step tracking-history-step1 hidden">
                            <span class="tracking-history-icon"></span>
                            <span class="tracking-history-box">
                                <strong class="tracking-history-status"><?php echo __('Order in the system','datalogics_shipping')?></strong>
                                <span class="tracking-history-date"></span>
                            </span>                            
                        </div>

                    </div>
                </div>

            </div>
        </div>
        <?php
        
        if (get_current_user_id()) {

            $args = array(
                'customer_id' => get_current_user_id(),
                'limit' => 10,
                //'return' => 'ids',
                'meta_query' => array(
                    array(
                        'key' => 'datalogics_shipping',
                        'value' => '',
                        'compare' => '!=',
                    ),
                ),
            );
            
            $query = new WC_Order_Query( $args );
            $orders = $query->get_orders();

            if (count($orders)>0) {
            ?>
            <h2 class="tracking-orders-list"><?php echo __('My Orders List','datalogics_shipping')?></h1>               
            <div class="shipping-number">
                <?php
                $counter = 0;           
                
                foreach( $orders as $order ) {
                    //$order = new WC_Order($order->ID);
                    $order = $order->get_data();

                    $counter++;

                    if ($counter==1) {
                        ?>
                    <div class="tracking_header">
                        <div><?php echo __('Order Number','datalogics_shipping')?></div>
                        <div><?php echo __('Customer Name','datalogics_shipping')?></div>
                        <div><?php echo __('Customer Address','datalogics_shipping')?></div>
                        <div><?php echo __('Order Value','datalogics_shipping')?></div>
                        <div><?php echo __('Order Date','datalogics_shipping')?></div>
                        <?php /*<div><?php echo __('Delivery Date','datalogics_shipping')?></div>*/?>
                        <div><?php echo __('Tracking Number','datalogics_shipping')?></div>
                        <div><?php echo __('Status','datalogics_shipping')?></div>
                        <div></div>                    
                    </div>
                        <?php
                    }

                    $tracking = '';
                    $order_tracking_status = '';
                    $final_status = __('Order in the system','datalogics_shipping');
                    



                    foreach($order['meta_data'] as $meta) {
                        

                        $meta = (array)$meta;
                        $meta = end($meta);

                        if ($meta['key']=='datalogics_shipping') {

                            $data = json_decode($meta['value']); 
                            $tracking = $data->tracking_number;

                        }   
                        
                        if ($meta['key']=='datalogics_shipping_status') {
                            $order_tracking_status = $meta['value'];
                            if ($order_tracking_status=='') {

                                $order_tracking_status = json_decode($order_tracking_status,true);
                                foreach($order_tracking_status as $status) {
                                    
                                    $final_status = $status['status'];

                                }

                            }
                        }


                        
                    }

                    //die;

                    ?>
                    <div class="tracking_cells">
                        <div>#<?php echo $order['id']?> </div>
                        <div>
                            <?php echo ($order['shipping']['first_name']!='') ? $order['shipping']['first_name'] : $order['billing']['first_name'] ?> 
                            <?php echo ($order['shipping']['last_name']='') ? $order['shipping']['last_name'] : $order['billing']['last_name'] ?>
                            <?php echo ($order['shipping']['company']!='') ? $order['shipping']['company'] : $order['billing']['company'] ?> 
                        </div>
                        <div>
                            <?php echo ($order['shipping']['address_1']!='') ? $order['shipping']['address_1'] : $order['billing']['address_1'] ?> 
                            <?php echo ($order['shipping']['address_2']!='') ? $order['shipping']['address_2'] : $order['billing']['address_2'] ?>
                            <?php echo ($order['shipping']['city']!='') ? $order['shipping']['city'] : $order['billing']['city'] ?> 
                        </div>
                        <div><?php echo $order['total']?> </div>
                        <div><?php echo date("Y-m-d",strtotime($order['date_modified']))?></div>
                        <?php /*<div><?php echo date("Y-m-d",strtotime($order['date_modified']))?></div>*/?>
                        <div>
                        <?php if ($tracking!='') {
                            ?>                        
                            <?php echo $tracking?>
                            <?php
                        } else  {
                            ?>
                            <?php echo __('No tracking yet','datalogics_shipping')?>
                            <?php
                        }                        
                        ?>
                        </div>
                        <div><span class="tracking-last-status"><?php echo $final_status; ?></span></div>
                        <div class="tracking_cells_last"></div>                    
                    </div>
                    <div class="tracking_cells big">
                        <div>
                            <div><strong class="tracking-history-title"><?php echo __('Order History','datalogics_shipping')?></strong></div>
                            <div class="tracking-history-step tracking-history-step1">
                                <span class="tracking-history-icon"></span>
                                <span class="tracking-history-box">
                                    <strong class="tracking-history-status"><?php echo __('Order in the system','datalogics_shipping')?></strong>
                                    <span class="tracking-history-date"><?php echo date("Y-m-d H:i",strtotime($order['date_modified']))?></span>
                                </span>                            
                            </div>
                            <?php
                            if (is_array($order_tracking_status)) {

                                foreach($order_tracking_status as $status) {
                                    
                                    ?>
                                    <div class="tracking-history-step tracking-history-step1">
                                        <span class="tracking-history-icon"></span>
                                        <span class="tracking-history-box">
                                            <strong class="tracking-history-status"><?php echo $status['status']?></strong>
                                            <span class="tracking-history-date"><?php echo date("Y-m-d H:i",strtotime($status['date']))?></span>
                                        </span>                            
                                    </div>
                                    <?php

                                }

                            }
                            ?>
                        </div>
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                        <div></div>
                        <div>
                            &nbsp;<br>
                            &nbsp;<br>
                            &nbsp;<br>
                            &nbsp;<br>
                            &nbsp;<br>
                            &nbsp;<br>
                        </div>
                    </div>
                    <?php
                    
                }
                ?>            
            </div>
            <?php 
            }
        }
        ?>
    </div>
        
        
    <?php
    /*
    <div class="tracking-powered"><?php echo __('Powered by','datalogics_shipping')?><span class="image"></span></div>
    */

}

?>